// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 15:15:51 

// Source File Name:   [DashoPro-V1.2-120198]

package communities;

import communities.pob.User2D;
import communities.utl.AppletStatus;
import communities.utl.ResourceInfo;
import java.applet.Applet;
import java.awt.*;

// Referenced classes of package communities:
//            IPalaceCore, PalaceIntro, Palace2DCanvas

public class AnimThread extends Thread {

    PalaceIntro itsIntro;

    private void showChatAnimation() {
        IPalaceCore itsCore = itsIntro.itsCore;
        java.awt.TextField textInput = itsCore.getTextInput();
        java.awt.Label chatLabel = itsCore.getChatLabel();
        int newX = 500;
        int newY = 0;
        int newWidth = 12;
        for(int i = 0; i < 20; i++) {
            newX -= 17;
            newY += 17;
            newWidth += 18;
            textInput.reshape(newX, newY, newWidth, 22);
            chatLabel.move(newX - 158, newY);
            if(itsCore.getAppletStatus().msFlag)
                itsIntro.pause(10);
            else
                itsIntro.pause(5);
        }

        textInput.reshape(158, 386, 354, 22);
        chatLabel.move(0, 386);
        for(int i = 0; i < 2; i++) {
            itsIntro.pause(500);
            if(itsIntro.bTerminate)
                break;
            chatLabel.hide();
            itsIntro.pause(500);
            if(itsIntro.bTerminate)
                break;
            chatLabel.show();
        }

        itsIntro.pause(500);
        itsIntro.as.introState = 6;
        itsIntro.demoPanel.remove(textInput);
        itsIntro.demoPanel.remove(chatLabel);
        ResourceInfo resInfo = itsCore.getResourceInfo();
        textInput.reshape(resInfo.textInputRect.x + 158, resInfo.textInputRect.y, resInfo.textInputRect.width - 158, resInfo.textInputRect.height);
        ((Applet)itsCore).add(textInput);
        chatLabel.reshape(resInfo.textInputRect.x, resInfo.textInputRect.y, 158, 22);
        ((Applet)itsCore).add(chatLabel);
        itsIntro.cleanUpAndConnect();
    }

    public AnimThread(PalaceIntro itsIntro) {
        super("AnimThread");
        this.itsIntro = null;
        this.itsIntro = itsIntro;
    }

    private void showUserAnimation() {
        User2D fakeUser = itsIntro.fakeUser;
        double x = 0.0D;
        double y = 0.0D;
        double xd = 4D;
        double yd = 0.0D;
        double gravityY = 0.40000000000000002D;
        double dampen = 0.97999999999999998D;
        for(int i = 0; i < 60; i++) {
            double nx = x + xd;
            double ny = y + yd;
            if(nx < 0.0D) {
                xd = -(xd * dampen);
                nx = -nx;
            }
            if(nx > 512D) {
                xd = -(xd * dampen);
                nx -= 2D * (nx - 512D);
            }
            if(ny > 384D) {
                yd = -(yd * dampen);
                ny -= 2D * (ny - 384D);
            }
            x = nx;
            y = ny;
            yd += gravityY;
            fakeUser.setXY((int)x, (int)y);
            itsIntro.canvas.drawRightNow();
            itsIntro.pause(5);
        }

        fakeUser.speech("This is you.", false);
        itsIntro.pause(1500);
        if(itsIntro.bTerminate) {
            itsIntro.cleanUpAndConnect();
            return;
        } else {
            fakeUser.speech("To move, click where you want to go.  Try it now!", false);
            itsIntro.nextButton.enable();
            itsIntro.replayButton.enable();
            return;
        }
    }

    public void run() {
        switch(itsIntro.as.introState) {
        case 2: // '\002'
            showUserAnimation();
            break;

        case 3: // '\003'
            showDoorsAnimation();
            break;

        case 5: // '\005'
            showChatAnimation();
            break;
        }
    }

    private void showDoorsAnimation() {
        User2D fakeUser = itsIntro.fakeUser;
        fakeUser.speech("Doorways to other rooms highlight when your mouse passes over them.  Try it!", false);
        itsIntro.canvas.drawRightNow();
        itsIntro.pause(3500);
        if(itsIntro.bTerminate) {
            itsIntro.cleanUpAndConnect();
            return;
        } else {
            itsIntro.as.introState++;
            fakeUser.speech("Click on the door when you're ready to enter The Palace.", false);
            itsIntro.replayButton.enable();
            itsIntro.nextButton.enable();
            return;
        }
    }
}
