// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 15:15:51 

// Source File Name:   [DashoPro-V1.2-120198]

package communities;

import communities.adm.IAdministrator;
import communities.pkt.PPEvent;
import communities.plg.IPalacePresents;
import communities.plg.PluginMgr;
import communities.pob.IScriptMgr;
import communities.pob.PalaceCommander;
import communities.pob.PropTable;
import communities.pob.Room2D;
import communities.utl.AppletStatus;
import communities.utl.Connection;
import communities.utl.PalaceSoundManager;
import communities.utl.PalaceURL;
import communities.utl.ResourceInfo;
import java.applet.Applet;
import java.awt.*;
import java.io.IOException;
import java.util.Vector;

// Referenced classes of package communities:
//            PalaceErrorHandler, Tooltip, IPalaceUI, Palace2DCanvas

public interface IPalaceCore {

    public abstract PluginMgr getPluginMgr();

    public abstract void setUserName(String s);

    public abstract void setRoomList(Vector vector);

    public abstract void hideUI();

    public abstract void handleRoomListRefresh();

    public abstract TextField getTextInput();

    public abstract void gotoRoom(int i, int j);

    public abstract String buildUserString(int i);

    public abstract boolean isNavInProgress();

    public abstract PalaceCommander getPalaceCommander();

    public abstract void setInputFocus();

    public abstract void connectToPalace();

    public abstract void gotoURL(String s, String s1);

    public abstract void gotoURL(PalaceURL palaceurl, String s);

    public abstract Room2D getRoom();

    public abstract void gotoNewRoom(int i);

    public abstract int getRoomListCount();

    public abstract void runIntro();

    public abstract PalaceSoundManager getSoundManager();

    public abstract PalaceErrorHandler getErrorHandler();

    public abstract Frame getAppletFrame();

    public abstract Image retrieveImage(String s, boolean flag);

    public abstract void showStatus();

    public abstract IPalacePresents getPalacePresents();

    public abstract Tooltip getTooltip();

    public abstract IAdministrator getAdmin();

    public abstract void handleRoomGoto(int i);

    public abstract IPalaceUI getUI();

    public abstract String buildRoomString(int i);

    public abstract void setCursor(int i);

    public abstract PropTable getPropTable();

    public abstract AppletStatus getAppletStatus();

    public abstract void setNavInProgress(boolean flag);

    public abstract int getUserListCount();

    public abstract void handleUserGoto(int i);

    public abstract PPEvent readPPEvent() throws IOException;

    public abstract IScriptMgr getScriptMgr();

    public abstract ResourceInfo getResourceInfo();

    public abstract void handleEventInfo();

    public abstract void NewRoomDesc(PPEvent ppevent, boolean flag);

    public abstract int getUserID();

    public abstract void setUserList(Vector vector);

    public abstract void handleEventJoin();

    public abstract Label getChatLabel();

    public abstract Palace2DCanvas getCanvas();

    public abstract Connection getConnection();

    public abstract void handleUserListRefresh();

    public abstract Applet getJavaApplet();

    public abstract void sendPPEvent(PPEvent ppevent);

    public abstract void showUI();

    public abstract Label getStatusLabel();

    public abstract String getUserName();
}
