// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 15:15:51 

// Source File Name:   [DashoPro-V1.2-120198]

package communities;

import java.awt.*;

public class LogArea extends TextArea {

    private int m_LogLen;
    private int m_prefWidth;
    private int m_prefHeight;
    protected FontMetrics m_FontMetrics;
    protected Font m_font;

    public LogArea(boolean editable, Color bgColor, int prefWidth, int prefHeight) {
        m_LogLen = 0;
        m_prefWidth = -1;
        m_prefHeight = -1;
        m_FontMetrics = null;
        m_font = null;
        setEditable(editable);
        setBackground(bgColor);
        m_font = new Font("Helvetica", 0, 12);
        setFont(m_font);
        m_FontMetrics = getFontMetrics(m_font);
        m_prefWidth = prefWidth;
        m_prefHeight = prefHeight;
    }

    public Dimension preferredSize() {
        Dimension dim = null;
        if(m_prefWidth == -1 && m_prefHeight == -1)
            dim = getParent().size();
        else
            dim = new Dimension(m_prefWidth, m_prefHeight);
        return dim;
    }

    public void appendText(String text) {
        int lineLen = 0;
        int msgLen = 0;
        int i = 0;
        int bookmark = 0;
        String logMsg = new String(text);
        msgLen = logMsg.length();
        char msgChars[] = new char[msgLen];
        logMsg.getChars(0, msgLen, msgChars, 0);
        m_LogLen += msgLen;
        if(m_LogLen > 16384) {
            String logText = getText();
            m_LogLen = logText.length();
            char logChars[] = new char[m_LogLen];
            logText.getChars(0, m_LogLen, logChars, 0);
            m_LogLen -= 4096;
            String newLogText = new String(logChars, 4095, m_LogLen);
            setText(newLogText);
            appendText("\n");
            m_LogLen++;
        }
        for(; i < msgLen; i++) {
            if(msgChars[i] == '\n')
                lineLen = 0;
            else
                lineLen += m_FontMetrics.charWidth(msgChars[i]);
            if((double)lineLen >= (double)size().width * 0.94999999999999996D) {
                bookmark = i;
                while(msgChars[i] != ' ')  {
                    if(--i == 0) {
                        i = bookmark;
                        break;
                    }
                    if(msgChars[i] == ' ') {
                        msgChars[i] = '\n';
                        lineLen = 0;
                        break;
                    }
                }
            }
        }

        String newMsg = new String(msgChars);
        super.appendText(newMsg);
    }
}
