// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 15:16:21 

// Source File Name:   [DashoPro-V1.2-120198]

package communities;

import java.applet.Applet;
import java.io.PrintStream;

public class PalaceErrorHandler {

    public static final String ErrorStrings[] = {
        "INFO", "WARNING", "ERROR", "FAILURE"
    };
    Applet myApplet;

    public PalaceErrorHandler(Applet applet) {
        myApplet = null;
        myApplet = applet;
    }

    private void handleWarning(String errorMsg) {
        myApplet.showStatus(errorMsg);
        System.err.println(errorMsg);
    }

    public void reportError(String errorMsg, int errorLevel) {
        switch(errorLevel) {
        case 0: // '\0'
            handleInfo(errorMsg);
            break;

        case 1: // '\001'
            handleWarning(errorMsg);
            break;

        case 2: // '\002'
            handleError(errorMsg);
            break;

        case 3: // '\003'
            handleFailure(errorMsg);
            break;
        }
    }

    private void handleInfo(String errorMsg) {
        myApplet.showStatus(errorMsg);
        System.err.println(errorMsg);
    }

    private void handleError(String errorMsg) {
        myApplet.showStatus(errorMsg);
        System.err.println(errorMsg);
    }

    private void handleFailure(String errorMsg) {
        System.err.println(ErrorStrings[3] + ": " + errorMsg);
        myApplet.stop();
    }

}
