// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 15:16:33 

// Source File Name:   [DashoPro-V1.2-120198]

package communities;

import communities.pob.Room;
import communities.pob.Room2D;
import communities.pob.User;
import communities.pob.User2D;
import communities.utl.AppletStatus;
import communities.utl.ResourceInfo;
import java.applet.Applet;
import java.awt.*;

// Referenced classes of package communities:
//            IPalaceCore, BorderPanel, FaceCanvas, Palace2DCanvas, 
//            AnimThread, IPalaceUI, PCycleCanvas, NameField

public class PalaceIntro extends Panel {

    IPalaceCore itsCore;
    Applet itsApplet;
    IPalaceUI itsUI;
    ResourceInfo resInfo;
    Palace2DCanvas canvas;
    NameField nameInput;
    Label nameLabel;
    Label welcomeLabel;
    Label welcomeLabel2;
    Button nameOK;
    Button avOK;
    Button replayButton;
    Button nextButton;
    Button skipButton;
    Button enterButton;
    Button demoButton;
    PCycleCanvas homeCanvas;
    CardLayout layout;
    BorderPanel buttonPanel;
    Panel getNamePanel;
    Panel avPanel;
    Panel demoPanel;
    FaceCanvas faceCanvas;
    User2D fakeUser;
    BorderPanel namePanel;
    Rectangle destRect;
    AnimThread animThread;
    public String userName;
    public int faceNbr;
    int mouseX;
    int mouseY;
    boolean bClicking;
    boolean bTerminate;
    boolean bWaitingForButton;
    boolean bReplaying;
    public AppletStatus as;

    private void finishGettingName() {
        userName = cutToLegalLength(nameInput.getText());
        if(userName.compareTo("") == 0)
            userName = new String("Guest");
        itsCore.setUserName(userName);
        getNamePanel.remove(namePanel);
        namePanel.remove(nameLabel);
        namePanel = null;
        System.gc();
    }

    private void initAvPanel() {
        Panel choosePanel = new BorderPanel(0, 0, 2, 2);
        choosePanel.setLayout(null);
        choosePanel.reshape(65, 10, 350, 390);
        avPanel.add(choosePanel);
        Label chooseLabel = new Label("Next, choose an Avatar to represent you:");
        chooseLabel.reshape(24, 14, 320, 20);
        Label chooseLabel2 = new Label("(It may take a few seconds to download the avatars)");
        chooseLabel2.reshape(16, 34, 330, 20);
        if(as.isMacintosh) {
            chooseLabel.setFont(new Font("Dialog", 1, 12));
            chooseLabel2.setFont(new Font("Dialog", 0, 10));
        } else {
            chooseLabel.setFont(new Font("Dialog", 1, 14));
            chooseLabel2.setFont(new Font("Dialog", 0, 12));
        }
        choosePanel.add(chooseLabel);
        choosePanel.add(chooseLabel2);
        faceCanvas = new FaceCanvas(itsCore.getResourceInfo());
        faceCanvas.reshape(54, 60, 226, 240);
        choosePanel.add(faceCanvas);
        try {
            enterButton = new Button(resInfo.customStringList[3]);
        }
        catch(NullPointerException e) {
            enterButton = new Button("Enter The Palace now");
        }
        enterButton.reshape(40, 314, 260, 24);
        choosePanel.add(enterButton);
        if(resInfo.tutorialEnabled) {
            try {
                demoButton = new Button(resInfo.customStringList[4]);
            }
            catch(NullPointerException e) {
                demoButton = new Button("Show me how The Palace works");
            }
            demoButton.reshape(40, 344, 260, 24);
            choosePanel.add(demoButton);
        }
    }

    public PalaceIntro(IPalaceCore itsCore, IPalaceUI itsUI) {
        this.itsCore = null;
        itsApplet = null;
        this.itsUI = null;
        resInfo = null;
        canvas = null;
        nameInput = null;
        nameLabel = null;
        welcomeLabel = null;
        welcomeLabel2 = null;
        nameOK = null;
        avOK = null;
        replayButton = null;
        nextButton = null;
        skipButton = null;
        enterButton = null;
        demoButton = null;
        homeCanvas = null;
        layout = null;
        buttonPanel = null;
        getNamePanel = null;
        avPanel = null;
        demoPanel = null;
        faceCanvas = null;
        fakeUser = null;
        namePanel = null;
        destRect = null;
        animThread = null;
        userName = null;
        faceNbr = 0;
        mouseX = 0;
        mouseY = 0;
        bClicking = false;
        bTerminate = false;
        bWaitingForButton = true;
        bReplaying = false;
        this.itsCore = itsCore;
        itsApplet = itsCore.getJavaApplet();
        as = itsCore.getAppletStatus();
        this.itsUI = itsUI;
        resInfo = itsCore.getResourceInfo();
        setBackground(Color.lightGray);
        setLayout(new CardLayout());
        if(resInfo.chooseNameEnabled) {
            getNamePanel = new Panel();
            getNamePanel.setLayout(null);
            getNamePanel.reshape(0, 0, 512, 430);
        }
        if(resInfo.chooseAvatarEnabled) {
            avPanel = new Panel();
            avPanel.setLayout(null);
            avPanel.reshape(0, 0, 512, 430);
        }
        if(resInfo.tutorialEnabled) {
            demoPanel = new Panel();
            demoPanel.setLayout(null);
            demoPanel.reshape(0, 0, 512, 430);
        }
    }

    private void chooseAvatar() {
        if(resInfo.chooseNameEnabled)
            layout.next(this);
        else
            layout.first(this);
        enterButton.requestFocus();
    }

    private void finishChoosingAvatar() {
        faceNbr = faceCanvas.getFaceID();
        fakeUser = new User2D(itsCore.getRoom(), userName, 100, 0, 0, 1, faceNbr, 3, 0, 0, 0, null, null);
        itsCore.getRoom().addUser(fakeUser);
    }

    private void showUser() {
        if(!bReplaying) {
            if(!resInfo.chooseNameEnabled && !resInfo.chooseAvatarEnabled)
                layout.first(this);
            else
                layout.next(this);
            if(!resInfo.chooseNameEnabled)
                userName = resInfo.defaultName;
            if(!resInfo.chooseAvatarEnabled) {
                fakeUser = new User2D(itsCore.getRoom(), userName, 100, 0, 0, 1, resInfo.defaultAvatar, resInfo.defaultFaceColor, 0, 0, 0, null, null);
                itsCore.getRoom().addUser(fakeUser);
            }
            canvas.show();
            canvas.drawRightNow();
        } else {
            bReplaying = false;
            fakeUser.clearBalloon();
        }
        animThread = new AnimThread(this);
        animThread.start();
    }

    public void showHowToChat() {
        itsCore.getRoom().setHotspotTarget(null);
        demoPanel.remove(canvas);
        itsApplet.add(canvas);
        demoPanel.remove(buttonPanel);
        itsCore.getRoom().removeUser(fakeUser.id());
        java.awt.TextField textInput = itsCore.getTextInput();
        Label chatLabel = itsCore.getChatLabel();
        itsApplet.remove(textInput);
        itsApplet.remove(chatLabel);
        textInput.reshape(500, 0, 12, 22);
        chatLabel.reshape(342, 0, 158, 22);
        demoPanel.add(textInput);
        demoPanel.add(chatLabel);
        textInput.show();
        chatLabel.show();
        animThread = new AnimThread(this);
        animThread.setDaemon(true);
        animThread.start();
    }

    private String cutToLegalLength(String name) {
        if(name.length() <= 20)
            return name;
        else
            return name.substring(0, 20);
    }

    public void cleanUpAndConnect() {
        itsCore.getRoom().setHotspotTarget(null);
        if(resInfo.tutorialEnabled) {
            demoPanel.remove(canvas);
            itsApplet.add(canvas);
            demoPanel.remove(buttonPanel);
            itsCore.getRoom().removeUser(fakeUser.id());
            fakeUser = null;
        }
        System.gc();
        itsCore.connectToPalace();
    }

    public void pause(int msecs) {
        int sleepCount = msecs / 100;
        if(sleepCount == 0)
            sleepCount = 1;
        try {
            for(int i = 0; i < sleepCount; i++) {
                if(msecs < 100)
                    Thread.sleep(msecs);
                else
                    Thread.sleep(100L);
                if(bTerminate)
                    return;
            }

        }
        catch(InterruptedException e) { }
    }

    private void showDoors() {
        as.introState = 3;
        fakeUser.clearBalloon();
        replayButton.disable();
        nextButton.disable();
        animThread = new AnimThread(this);
        animThread.start();
    }

    public void run() {
        if(resInfo.chooseNameEnabled) {
            initNamePanel();
            add("getNamePanel", getNamePanel);
        }
        if(resInfo.chooseAvatarEnabled) {
            initAvPanel();
            add("avPanel", avPanel);
        }
        if(resInfo.tutorialEnabled) {
            initDemoPanel();
            add("demoPanel", demoPanel);
        }
        layout = (CardLayout)getLayout();
        if(resInfo.chooseNameEnabled) {
            as.introState = 0;
            getUserName();
        } else
        if(resInfo.chooseAvatarEnabled) {
            as.introState = 1;
            chooseAvatar();
        } else
        if(resInfo.tutorialEnabled) {
            as.introState = 2;
            showUser();
        }
    }

    public boolean handleEvent(Event evt) {
        boolean retval = super.handleEvent(evt);
        switch(evt.id) {
        case 1001: // Event.ACTION_EVENT
            if(evt.target == nameOK) {
                finishGettingName();
                if(resInfo.chooseAvatarEnabled) {
                    as.introState = 1;
                    chooseAvatar();
                    return retval;
                }
                if(resInfo.tutorialEnabled) {
                    as.introState = 2;
                } else {
                    bTerminate = true;
                    cleanUpAndConnect();
                    return retval;
                }
            } else
            if(evt.target == demoButton) {
                finishChoosingAvatar();
                as.introState++;
            } else {
                if(evt.target == enterButton) {
                    finishChoosingAvatar();
                    bTerminate = true;
                    cleanUpAndConnect();
                    return retval;
                }
                if(evt.target == nextButton)
                    as.introState++;
                else
                if(evt.target == replayButton)
                    bReplaying = true;
                else
                if(evt.target == skipButton) {
                    bTerminate = true;
                    cleanUpAndConnect();
                    return retval;
                }
            }
            switch(as.introState) {
            case 2: // '\002'
                showUser();
                break;

            case 3: // '\003'
            case 4: // '\004'
                showDoors();
                break;

            case 5: // '\005'
                showHowToChat();
                break;

            case 6: // '\006'
                cleanUpAndConnect();
                break;
            }
            return retval;

        case 401: // Event.KEY_PRESS
            if(evt.target == nameInput && evt.key == 10) {
                finishGettingName();
                if(resInfo.chooseAvatarEnabled) {
                    as.introState = 1;
                    chooseAvatar();
                    return retval;
                }
                if(resInfo.tutorialEnabled) {
                    as.introState = 2;
                    showUser();
                } else {
                    bTerminate = true;
                    cleanUpAndConnect();
                    return retval;
                }
            }
            if(evt.target == enterButton && evt.key == 10) {
                finishChoosingAvatar();
                bTerminate = true;
                cleanUpAndConnect();
                return retval;
            }
            if(evt.key == 27) {
                bTerminate = true;
                cleanUpAndConnect();
                return retval;
            }
            break;
        }
        return retval;
    }

    private void initNamePanel() {
        namePanel = new BorderPanel(0, 0, 2, 2);
        namePanel.setLayout(null);
        namePanel.reshape(80, 90, 395, 155);
        getNamePanel.add(namePanel);
        try {
            welcomeLabel = new Label(resInfo.customStringList[0]);
        }
        catch(NullPointerException e) {
            welcomeLabel = new Label("Welcome to The Palace!");
        }
        welcomeLabel.setFont(new Font("Dialog", 1, 14));
        welcomeLabel.reshape(15, 10, 300, 30);
        namePanel.add(welcomeLabel);
        try {
            if(resInfo.customStringList[1] != null) {
                welcomeLabel2 = new Label(resInfo.customStringList[1]);
                welcomeLabel2.setFont(new Font("Dialog", 1, 14));
                welcomeLabel2.reshape(15, 30, 300, 30);
                namePanel.add(welcomeLabel2);
            }
        }
        catch(NullPointerException e) { }
        try {
            homeCanvas = new PCycleCanvas(itsUI.getHomeImage());
        }
        catch(NullPointerException e) {
            homeCanvas = new PCycleCanvas(null);
        }
        homeCanvas.reshape(339, 10, 34, 34);
        namePanel.add(homeCanvas);
        try {
            nameLabel = new Label(resInfo.customStringList[2]);
        }
        catch(NullPointerException e) {
            nameLabel = new Label("Type in the name you'd like to use in PalaceSpace:");
        }
        nameLabel.setFont(new Font("Dialog", 1, 12));
        nameLabel.reshape(15, 70, 375, 20);
        namePanel.add(nameLabel);
        nameInput = new NameField(32, 20);
        nameInput.reshape(20, 110, 310, 22);
        namePanel.add(nameInput);
        nameOK = new Button("OK");
        nameOK.reshape(334, 110, 40, 24);
        namePanel.add(nameOK);
    }

    private void initDemoPanel() {
        buttonPanel = new BorderPanel(0, 0, 2, 2);
        buttonPanel.setLayout(null);
        buttonPanel.reshape(248, 384, 264, 38);
        skipButton = new Button("Skip This");
        skipButton.reshape(6, 6, 100, 24);
        nextButton = new Button("Continue");
        nextButton.disable();
        nextButton.reshape(180, 6, 74, 24);
        nextButton.requestFocus();
        replayButton = new Button("Replay");
        replayButton.reshape(106, 6, 74, 24);
        replayButton.disable();
        buttonPanel.add(skipButton);
        buttonPanel.add(nextButton);
        buttonPanel.add(replayButton);
        demoPanel.add(buttonPanel);
        canvas = itsCore.getCanvas();
        itsApplet.remove(canvas);
        demoPanel.add(canvas);
        canvas.show();
    }

    public void getUserName() {
        String n = itsCore.getUserName();
        if(n != null) {
            nameInput.setText(n);
            nameInput.selectAll();
        }
        layout.first(this);
        nameInput.requestFocus();
    }
}
