// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 15:16:54 

// Source File Name:   [DashoPro-V1.2-120198]

package communities;

import java.awt.*;

// Referenced classes of package communities:
//            IPalaceCore

public class PalaceRoomList extends Panel {

    private Button mRefreshButton;
    private Button mGotoButton;
    private List mRoomList;
    private IPalaceCore mCore;

    public void addRoom(String roomName) {
        mRoomList.addItem(roomName);
    }

    public PalaceRoomList(IPalaceCore itsCore) {
        mRefreshButton = null;
        mGotoButton = null;
        mRoomList = null;
        mCore = null;
        mCore = itsCore;
        setLayout(new BorderLayout());
        Label roomListLabel = new Label("Room                  Users");
        roomListLabel.setFont(new Font("Courier", 1, 12));
        add("North", roomListLabel);
        mRoomList = new List(0, false);
        add("Center", mRoomList);
        mRoomList.setBackground(new Color(0xffffff));
        mRoomList.setFont(new Font("Courier", 0, 12));
        mGotoButton = new Button("Goto");
        mRefreshButton = new Button("Refresh");
        Panel p = new Panel();
        p.setLayout(new FlowLayout(1));
        p.add(mGotoButton);
        p.add(mRefreshButton);
        add("South", p);
    }

    public void paint(Graphics g) {
        Color save = g.getColor();
        Dimension size = size();
        g.setColor(Color.white);
        g.drawRect(1, 1, size.width - 2, size.height - 2);
        g.setColor(Color.gray);
        g.drawRect(0, 0, size.width - 2, size.height - 2);
        g.setColor(save);
    }

    public void select(int index) {
        mRoomList.select(index);
    }

    public boolean action(Event e, Object arg) {
        boolean handled = false;
        if(e.target == mGotoButton) {
            mCore.handleRoomGoto(mRoomList.getSelectedIndex());
            handled = true;
        } else
        if(e.target == mRefreshButton) {
            mCore.handleRoomListRefresh();
            handled = true;
        } else
        if(e.target == mRoomList) {
            mCore.handleRoomGoto(mRoomList.getSelectedIndex());
            handled = true;
        } else {
            handled = super.action(e, arg);
        }
        return handled;
    }

    public void clear() {
        mRoomList.clear();
    }

    public Insets insets() {
        return new Insets(3, 3, 3, 3);
    }

    public boolean keyDown(Event e, int key) {
        boolean handled;
        if(e.target == mRoomList && (key == 10 || key == 13)) {
            mCore.handleRoomGoto(mRoomList.getSelectedIndex());
            handled = true;
        } else {
            handled = super.keyDown(e, key);
        }
        return handled;
    }
}
