// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 14:52:51 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.pkt;

import communities.utl.NetDataInputStream;
import communities.utl.NetDataOutputStream;
import java.io.*;

// Referenced classes of package communities.pkt:
//            PPEvent

public class PPEventExtendedInfo extends PPEvent {

    public int flags;
    public String avatarDir;
    public String strVERS;
    public String strTYPE;
    public int intFLAG;
    public int intNUSR;
    public String strNAME;
    public String strUNKN;
    public String strFLAG;
    public int intCAPT;
    public int intPLAT;
    public String pictureDir;

    public PPEventExtendedInfo() {
        flags = 0;
        avatarDir = null;
        strVERS = null;
        strTYPE = null;
        intFLAG = 0;
        intNUSR = 0;
        strNAME = null;
        strUNKN = null;
        strFLAG = null;
        intCAPT = 0;
        intPLAT = 0;
        pictureDir = null;
    }

    public void read(NetDataInputStream ndis) throws IOException {
        byte dataArr[] = new byte[length()];
        ndis.readFully(dataArr);
        ByteArrayInputStream bais = new ByteArrayInputStream(dataArr);
        NetDataInputStream ba_ndis = new NetDataInputStream(bais);
        ba_ndis.setBigEndian(ndis.isBigEndian());
        while(ba_ndis.available() >= 8)  {
            int id = ba_ndis.readInt();
            int len = ba_ndis.readInt();
            byte data[] = new byte[len];
            ba_ndis.readFully(data);
            switch(id) {
            default:
                break;

            case 1096110668: 
                avatarDir = new String(data, 0);
                break;

            case 1447383635: 
                strVERS = new String(data, 0);
                break;

            case 1415139397: 
                strTYPE = new String(data, 0);
                break;

            case 1179402567: 
                ByteArrayInputStream flag_is = new ByteArrayInputStream(data);
                NetDataInputStream flag_ndis = new NetDataInputStream(flag_is);
                flag_ndis.setBigEndian(ndis.isBigEndian());
                intFLAG = flag_ndis.readInt();
                intCAPT = flag_ndis.readInt();
                intCAPT = intCAPT != 0 ? intCAPT : 3;
                intPLAT = flag_ndis.readByte();
                StringBuffer strBuff = new StringBuffer(0);
                if((intFLAG & 1) == 1)
                    strBuff.append("DirectPlay ");
                if((intFLAG & 2) == 1)
                    strBuff.append("ClosedServer ");
                if((intFLAG & 4) == 1)
                    strBuff.append("GuestsAreMembers ");
                if((intFLAG & 8) == 1)
                    strBuff.append("Advertising ");
                strFLAG = strBuff.toString();
                break;

            case 1314214738: 
                ByteArrayInputStream nusr_is = new ByteArrayInputStream(data);
                NetDataInputStream nusr_ndis = new NetDataInputStream(nusr_is);
                nusr_ndis.setBigEndian(ndis.isBigEndian());
                intNUSR = nusr_ndis.readInt();
                break;

            case 1312902469: 
                strNAME = new String(data, 0);
                break;

            case 1213551180: 
                pictureDir = new String(data, 0);
                break;

            case 1431194446: 
                strUNKN = new String(data, 0);
                break;
            }
        }
        dataArr = null;
        System.gc();
    }

    public PPEventExtendedInfo(int userId) {
        flags = 0;
        avatarDir = null;
        strVERS = null;
        strTYPE = null;
        intFLAG = 0;
        intNUSR = 0;
        strNAME = null;
        strUNKN = null;
        strFLAG = null;
        intCAPT = 0;
        intPLAT = 0;
        pictureDir = null;
        super.event = 0x73496e66;
        super.size = 16;
        super.refNum = userId;
        flags = 127;
    }

    public void write(NetDataOutputStream ndos) throws IOException {
        super.writeNoFlush(ndos);
        ndos.writeInt(flags);
        ndos.writeInt(0x54595045);
        ndos.writeInt(4);
        ndos.writeBytes("Java");
        super.flush(ndos);
    }
}
