// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 14:52:51 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.pkt;

import communities.utl.NetDataInputStream;
import communities.utl.NetDataOutputStream;
import java.io.IOException;

// Referenced classes of package communities.pkt:
//            PPEvent

public class PPEventUserDesc extends PPEvent {

    public int colorNbr;
    public int faceNbr;
    public int nbrProps;
    public int propIDs[];
    public int propCRCs[];

    public PPEventUserDesc() {
        colorNbr = 0;
        faceNbr = 0;
        nbrProps = 0;
        propIDs = null;
        propCRCs = null;
    }

    public void read(NetDataInputStream ndis) throws IOException {
        faceNbr = ndis.readShort();
        colorNbr = ndis.readShort();
        nbrProps = ndis.readInt();
        propIDs = new int[9];
        propCRCs = new int[9];
        for(int i = 0; i < nbrProps; i++) {
            propIDs[i] = ndis.readInt();
            propCRCs[i] = ndis.readInt();
        }

    }

    public void write(NetDataOutputStream ndos) throws IOException {
        super.write(ndos);
        ndos.writeShort(faceNbr);
        ndos.writeShort(colorNbr);
        ndos.writeInt(nbrProps);
        for(int x = 0; x < nbrProps; x++) {
            ndos.writeLong(propIDs[x]);
            ndos.writeLong(propCRCs[x]);
        }

    }
}
