// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 14:52:51 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.pkt;

import communities.utl.NetDataInputStream;
import communities.utl.NetDataOutputStream;
import java.io.IOException;

// Referenced classes of package communities.pkt:
//            PPEvent

public class PPEventUserName extends PPEvent {

    public String userName;

    public PPEventUserName() {
        userName = null;
    }

    public void read(NetDataInputStream ndis) throws IOException {
        byte bs[] = new byte[super.size];
        ndis.readFully(bs);
        userName = new String(bs, 0, 1, bs[0]);
    }

    public PPEventUserName(int userID, String name) {
        userName = null;
        super.event = 0x7573724e;
        super.size = name.length() + 1;
        super.refNum = userID;
        userName = name;
    }

    public void write(NetDataOutputStream ndos) throws IOException {
        super.writeNoFlush(ndos);
        byte bs[] = new byte[32];
        int len = userName.length();
        if(len > 31)
            len = 31;
        bs[0] = (byte)len;
        userName.getBytes(0, len, bs, 1);
        ndos.write(bs, 0, len + 1);
        super.flush(ndos);
    }
}
