// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 14:52:51 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.pkt;

import communities.utl.*;
import java.io.IOException;

// Referenced classes of package communities.pkt:
//            PPEvent

public class PPEventXWhisper extends PPEvent {

    int targetID;
    String msg;

    public PPEventXWhisper() {
        targetID = 0;
        msg = null;
    }

    public void read(NetDataInputStream ndis) throws IOException {
        targetID = ndis.readShort();
        int strSize = ndis.readShort();
        byte bs[] = new byte[strSize - 3];
        ndis.readFully(bs);
        ndis.readByte();
        msg = TextCrypto.decryptString(new String(bs, 0));
    }

    public PPEventXWhisper(String msg, int userId, int targetID) {
        this.targetID = 0;
        this.msg = null;
        super.event = 0x78776973;
        super.size = msg.length() + 7;
        super.refNum = userId;
        this.targetID = targetID;
        this.msg = msg;
    }

    public void write(NetDataOutputStream ndos) throws IOException {
        String xmsg = TextCrypto.encryptString(msg);
        super.writeNoFlush(ndos);
        ndos.writeInt(targetID);
        ndos.writeShort(xmsg.length() + 3);
        ndos.writeBytes(xmsg);
        ndos.writeByte(0);
        super.flush(ndos);
    }
}
