// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 14:52:51 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.pkt;

import communities.*;
import communities.pob.Room2D;
import communities.utl.*;
import java.io.*;
import java.net.URLConnection;

// Referenced classes of package communities.pkt:
//            PPEvent

public class PalacePacketSender
    implements PalaceMsgStrings {

    Connection itsConn;
    IPalaceCore itsCore;

    public PalacePacketSender(Connection itsConn, IPalaceCore itsCore) {
        this.itsConn = null;
        this.itsCore = null;
        this.itsConn = itsConn;
        this.itsCore = itsCore;
    }

    public synchronized void sendPPEvent(PPEvent ppe) {
        try {
            NetDataStreams ndio = itsConn.getNDS();
            if(ndio == null)
                return;
            NetDataOutputStream ndos = (NetDataOutputStream)ndio.getNDOS();
            if(itsConn.isHTTPConn())
                ndos.writeInt(itsConn.getConnID());
            ppe.write(ndos);
            if(itsConn.isHTTPConn()) {
                ndos.flush();
                try {
                    URLConnection urlc = (URLConnection)ndio.getNDIS();
                    urlc.getInputStream().close();
                    ndos.close();
                }
                catch(Exception e) {
                    itsCore.getErrorHandler().reportError("PacketSender send exception = " + e.getMessage(), 1);
                }
            }
        }
        catch(IOException e) {
            String estr = "You have been disconnected due to a send error." + " (" + PPEvent.eventToString(ppe.event) + ") : " + e.getMessage();
            try {
                itsCore.getRoom().statusMessage("Problem", estr);
                itsCore.getErrorHandler().reportError(estr, 1);
            }
            catch(NullPointerException npe) {
                System.out.println("Problem" + " " + estr);
            }
        }
    }
}
