// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 14:53:14 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.plg;

import java.awt.*;

// Referenced classes of package communities.plg:
//            TextPanel, IMessageBoxParent

public class MessageBox extends Dialog
    implements IMessageBoxParent {

    IMessageBoxParent m_mbParent;
    String m_strMsg;
    int m_flags;
    Object m_usrData;
    Panel m_BtnPanel;
    Button m_OKBtn;
    Button m_CancelBtn;
    Button m_YesBtn;
    Button m_NoBtn;
    Object m_answer;
    int m_maxline;
    int m_LineCnt;
    String m_maxStr;

    public void addLabelPerLine(String msgTxt) {
        int i = 0;
        int start = 0;
        int j = 0;
        int len = msgTxt.length();
        m_maxline = 0;
        m_LineCnt = 0;
        char msgChars[] = new char[msgTxt.length()];
        msgTxt.getChars(0, len, msgChars, 0);
        for(; i < len; i++) {
            if(msgChars[i] == '\n') {
                String str = new String(msgChars, start, j);
                TextPanel tp = new TextPanel(str);
                int width = size().width;
                int tpwidth = tp.size().width;
                int tpheight = tp.size().height;
                tp.move((width - tpwidth) / 2, 30 + m_LineCnt * tpheight);
                add(tp);
                if(str.length() > m_maxline) {
                    m_maxline = str.length();
                    m_maxStr = str;
                }
                m_LineCnt++;
                j = -1;
                start = i + 1;
            }
            j++;
        }

        if(j != 0) {
            String str = new String(msgChars, start, j - 1);
            add(new TextPanel(str));
            if(str.length() > m_maxline) {
                m_maxline = str.length();
                m_maxStr = str;
            }
            m_LineCnt++;
        }
    }

    public MessageBox(IMessageBoxParent mbParent, Frame parentFrame, String strTitle, String strMsg, int flags, Object usrData) {
        super(parentFrame, strTitle, false);
        m_mbParent = null;
        m_strMsg = null;
        m_flags = 0;
        m_usrData = null;
        m_BtnPanel = null;
        m_OKBtn = null;
        m_CancelBtn = null;
        m_YesBtn = null;
        m_NoBtn = null;
        m_answer = null;
        m_maxline = 0;
        m_LineCnt = 0;
        m_maxStr = null;
        m_answer = null;
        m_mbParent = mbParent;
        m_strMsg = strMsg;
        m_flags = flags;
        m_usrData = usrData;
        setLayout(null);
        resize(340, 180);
        addLabelPerLine(strMsg);
        resize(340, 70 + 30 * m_LineCnt);
        m_BtnPanel = new Panel();
        m_BtnPanel.setLayout(new FlowLayout());
        int bwidth = 20;
        int bheight = 30;
        if(flags == 0 || (flags & 1) != 0) {
            m_OKBtn = (Button)m_BtnPanel.add(new Button("OK"));
            bwidth += 40;
        }
        if((flags & 4) != 0) {
            m_YesBtn = (Button)m_BtnPanel.add(new Button("Yes"));
            bwidth += 40;
        }
        if((flags & 8) != 0) {
            m_NoBtn = (Button)m_BtnPanel.add(new Button("No"));
            bwidth += 40;
        }
        if((flags & 2) != 0) {
            m_CancelBtn = (Button)m_BtnPanel.add(new Button("Cancel"));
            bwidth += 60;
        }
        m_BtnPanel.resize(bwidth, bheight);
        m_BtnPanel.move((340 - m_BtnPanel.size().width) / 2, size().height - (m_BtnPanel.size().height + 30));
        add(m_BtnPanel);
        setBackground(Color.lightGray);
    }

    public void paint(Graphics g1) {
    }

    public int getResponse() {
        if(m_answer != null) {
            if(m_answer == m_OKBtn)
                return 1;
            if(m_answer == m_CancelBtn)
                return 2;
            if(m_answer == m_YesBtn)
                return 4;
            if(m_answer == m_NoBtn)
                return 8;
        }
        return -1;
    }

    public void messageBoxDismissed(MessageBox messagebox) {
    }

    public void show() {
        Dimension screenD = Toolkit.getDefaultToolkit().getScreenSize();
        Frame TopFrame = null;
        for(Component c = this; c != null; c = c.getParent())
            if(c instanceof Frame)
                TopFrame = (Frame)c;

        Point FrameLoc;
        if(TopFrame != null)
            FrameLoc = TopFrame.location();
        else
            FrameLoc = new Point(100, 100);
        Dimension mySize = size();
        int x = (screenD.width - mySize.width) / 2;
        int y = (screenD.height - mySize.height) / 2;
        reshape(x, y, mySize.width, mySize.height);
        if(m_OKBtn != null)
            m_OKBtn.requestFocus();
        else
        if(m_YesBtn != null)
            m_YesBtn.requestFocus();
        else
        if(m_NoBtn != null)
            m_NoBtn.requestFocus();
        else
        if(m_CancelBtn != null)
            m_CancelBtn.requestFocus();
        super.show();
    }

    public boolean action(Event event, Object what) {
        m_answer = event.target;
        m_mbParent.messageBoxDismissed(this);
        return true;
    }

    public Object getUserData() {
        return m_usrData;
    }

    public Insets insets() {
        return new Insets(10, 10, 10, 10);
    }

    public boolean handleEvent(Event evt) {
        if(evt.id == 201)
            dispose();
        return super.handleEvent(evt);
    }
}
