// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 14:53:14 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.plg;

import communities.pkt.PPEvent;
import communities.utl.NetDataInputStream;
import communities.utl.NetDataOutputStream;
import java.io.IOException;

// Referenced classes of package communities.plg:
//            PPEventBlowThru, IPalPresentsEventTypes

public class PPPEvent extends PPEventBlowThru
    implements IPalPresentsEventTypes {

    protected short m_ProtVer;
    protected int m_AudCommand;
    protected int m_AudResult;
    protected int m_userID;
    protected int m_AudDataLen;
    protected int m_StageUserID;

    public String toString() {
        String s = new String();
        s = " PPP Event -> Prot Ver : " + m_ProtVer + " Command : " + m_AudCommand + " Result :  " + m_AudResult + " User ID : " + m_userID + " AudDataLen : " + m_AudDataLen + "\r ";
        return s;
    }

    public PPPEvent() {
        m_ProtVer = 0;
        m_AudCommand = 0;
        m_AudResult = 0;
        m_userID = 0;
        m_AudDataLen = 0;
        m_StageUserID = 0;
    }

    public PPPEvent(PPEventBlowThru ppBlowThru) {
        super(ppBlowThru);
        m_ProtVer = 0;
        m_AudCommand = 0;
        m_AudResult = 0;
        m_userID = 0;
        m_AudDataLen = 0;
        m_StageUserID = 0;
        super.m_BlowThruID = ppBlowThru.m_BlowThruID;
    }

    public PPPEvent(PPPEvent pppEvent) {
        super(pppEvent);
        m_ProtVer = 0;
        m_AudCommand = 0;
        m_AudResult = 0;
        m_userID = 0;
        m_AudDataLen = 0;
        m_StageUserID = 0;
        m_ProtVer = pppEvent.m_ProtVer;
        m_AudCommand = pppEvent.m_AudCommand;
        m_AudResult = pppEvent.m_AudResult;
        m_userID = pppEvent.m_userID;
        m_AudDataLen = pppEvent.m_AudDataLen;
        super.m_BlowThruID = ((PPEventBlowThru) (pppEvent)).m_BlowThruID;
    }

    public void read(NetDataInputStream ndis) throws IOException {
        m_ProtVer = ndis.readShort();
        m_AudCommand = ndis.readInt();
        m_AudResult = ndis.readInt();
        m_userID = ndis.readInt();
        m_AudDataLen = ndis.readInt();
    }

    public void write(NetDataOutputStream ndos) throws IOException {
        super.write(ndos);
        ndos.writeShort(m_ProtVer);
        ndos.writeInt(m_AudCommand);
        ndos.writeInt(m_AudResult);
        ndos.writeInt(m_userID);
        ndos.writeInt(m_AudDataLen);
    }

    public void SetUserID(int userID) {
        super.refNum = userID;
    }

    public void SetStageUserID(int StageUserID) {
        m_StageUserID = StageUserID;
    }

    public void setPalPresentHeader(int AudCommand, int AudResult, int userID, int AudDataLen) {
        m_AudCommand = AudCommand;
        m_AudResult = AudResult;
        m_userID = userID;
        m_AudDataLen = AudDataLen;
        int UserIDs[] = new int[1];
        UserIDs[0] = m_StageUserID;
        setBlowThruHeader(0, 1, UserIDs, 0x10040);
        m_ProtVer = 2;
        UserIDs = null;
        super.size = 12 + 4 * super.m_noofUsers + 18 + AudDataLen;
    }
}
