// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 14:53:14 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.plg;

import communities.utl.NetDataInputStream;
import communities.utl.NetDataOutputStream;
import java.io.IOException;

// Referenced classes of package communities.plg:
//            PPPEvent

public class PPPEventNewStage extends PPPEvent {

    protected byte m_visualNotify;
    protected String m_eventName;
    protected String m_eventInfoURL;

    public PPPEventNewStage(PPPEvent pppEvent) {
        super(pppEvent);
        m_visualNotify = 1;
        m_eventName = null;
        m_eventInfoURL = null;
        m_visualNotify = 1;
    }

    public void read(NetDataInputStream ndis) throws IOException {
        byte bs[] = new byte[super.m_AudDataLen];
        ndis.readFully(bs);
        int nameTermIdx = -1;
        int urlTermIdx = -1;
        int flagByteIdx = -1;
        for(int cnt = 0; cnt < bs.length; cnt++)
            if(bs[cnt] == 0 && nameTermIdx == -1)
                nameTermIdx = cnt;
            else
            if(bs[cnt] == 0 && urlTermIdx == -1) {
                urlTermIdx = cnt;
                flagByteIdx = cnt + 1;
            }

        if(nameTermIdx != -1)
            m_eventName = new String(bs, 0, 0, nameTermIdx);
        else
            m_eventName = "";
        if(urlTermIdx != -1)
            m_eventInfoURL = new String(bs, 0, nameTermIdx + 1, urlTermIdx - (nameTermIdx + 1));
        else
            m_eventInfoURL = "";
        if(flagByteIdx < bs.length)
            m_visualNotify = bs[flagByteIdx];
        else
            m_visualNotify = 1;
        bs = null;
    }

    public byte getVisualNotify() {
        return m_visualNotify;
    }

    public void write(NetDataOutputStream ndos) throws IOException {
        super.write(ndos);
    }
}
