// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 14:53:14 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.plg;

import communities.utl.NetDataInputStream;
import communities.utl.NetDataOutputStream;
import java.io.IOException;

// Referenced classes of package communities.plg:
//            PPPEvent

public class PPPEventQAPair extends PPPEvent {

    public String m_ques;
    public String m_ans;
    public int m_quesID;
    public int m_ansID;
    public static int DELAY_DEF = 0;
    public int m_delay;
    public int m_nxtDelay;

    public PPPEventQAPair(PPPEvent pppEvent) {
        super(pppEvent);
        m_ques = null;
        m_ans = null;
        m_quesID = 0;
        m_ansID = 0;
        m_delay = DELAY_DEF;
        m_nxtDelay = 0;
    }

    public void read(NetDataInputStream ndis) throws IOException {
        byte bs[] = new byte[super.m_AudDataLen];
        ndis.readFully(bs);
        int STRING_START = 12;
        m_delay = ((bs[3] & 0xff) << 24) + ((bs[2] & 0xff) << 16) + ((bs[1] & 0xff) << 8) + (bs[0] & 0xff);
        if(m_delay < 0)
            m_delay = DELAY_DEF;
        m_quesID = ((bs[7] & 0xff) << 24) + ((bs[6] & 0xff) << 16) + ((bs[5] & 0xff) << 8) + (bs[4] & 0xff);
        if(m_quesID < 0)
            m_quesID = -1;
        m_ansID = ((bs[11] & 0xff) << 24) + ((bs[10] & 0xff) << 16) + ((bs[9] & 0xff) << 8) + (bs[8] & 0xff);
        if(m_ansID < 0)
            m_ansID = -1;
        int quesTermIdx = -1;
        int ansTermIdx = -1;
        int nxtDelayIdx = -1;
        for(int cnt = STRING_START; cnt < bs.length; cnt++)
            if(bs[cnt] == 0 && quesTermIdx == -1)
                quesTermIdx = cnt;
            else
            if(bs[cnt] == 0 && ansTermIdx == -1) {
                ansTermIdx = cnt;
                nxtDelayIdx = cnt + 1;
            }

        if(quesTermIdx != -1)
            m_ques = new String(bs, 0, STRING_START, quesTermIdx - STRING_START);
        else
            m_ques = " ";
        if(ansTermIdx != -1 && quesTermIdx != -1 && ansTermIdx > quesTermIdx)
            m_ans = new String(bs, 0, quesTermIdx + 1, ansTermIdx - (quesTermIdx + 1));
        else
            m_ans = " ";
        if(bs.length > nxtDelayIdx + 3)
            m_nxtDelay = ((bs[nxtDelayIdx + 3] & 0xff) << 24) + ((bs[nxtDelayIdx + 2] & 0xff) << 16) + ((bs[nxtDelayIdx + 1] & 0xff) << 8) + (bs[nxtDelayIdx] & 0xff);
    }

    public void write(NetDataOutputStream ndos) throws IOException {
        super.write(ndos);
    }

}
