// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 14:53:14 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.plg;

import communities.pkt.PPEvent;
import communities.utl.NetDataInputStream;
import communities.utl.NetDataOutputStream;
import java.io.IOException;

// Referenced classes of package communities.plg:
//            PPPEvent, PPEventBlowThru

public class PPPEventTalk extends PPPEvent {

    public String m_ChatTxt;
    public static int DELAY_DEF = 0;
    public int m_delayLen;

    public String toString() {
        String s = new String();
        s = "\n\r Chat on Stage : " + m_ChatTxt + "\n\r";
        return s;
    }

    public PPPEventTalk(String ChatTxt) {
        m_ChatTxt = null;
        m_delayLen = DELAY_DEF;
        m_ChatTxt = new String(ChatTxt);
    }

    public PPPEventTalk(PPPEvent ppEvent) {
        super(ppEvent);
        m_ChatTxt = null;
        m_delayLen = DELAY_DEF;
    }

    public void read(NetDataInputStream ndis) throws IOException {
        byte bs[] = new byte[super.m_AudDataLen];
        ndis.readFully(bs);
        int strTermIdx = -1;
        int delayFlagIdx = -1;
        for(int cnt = 0; cnt < bs.length; cnt++)
            if(bs[cnt] == 0 && strTermIdx == -1) {
                strTermIdx = cnt;
                delayFlagIdx = cnt + 1;
            }

        if(strTermIdx != -1)
            m_ChatTxt = new String(bs, 0, 0, strTermIdx);
        if(delayFlagIdx + 3 < bs.length) {
            m_delayLen = ((bs[delayFlagIdx + 3] & 0xff) << 24) + ((bs[delayFlagIdx + 2] & 0xff) << 16) + ((bs[delayFlagIdx + 1] & 0xff) << 8) + (bs[delayFlagIdx] & 0xff);
            if(m_delayLen < 0)
                m_delayLen = DELAY_DEF;
        } else {
            m_delayLen = DELAY_DEF;
        }
        bs = null;
    }

    public void write(NetDataOutputStream ndos) throws IOException {
        setPalPresentHeader(6, 0, super.refNum, m_ChatTxt.length() + 1);
        super.write(ndos);
        byte bs[] = new byte[m_ChatTxt.length() + 1];
        m_ChatTxt.getBytes(0, m_ChatTxt.length(), bs, 0);
        bs[m_ChatTxt.length()] = 0;
        ndos.write(bs);
        bs = null;
        super.flush(ndos);
    }

}
