// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 14:53:14 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.plg;

import communities.*;
import communities.pkt.PPEvent;
import communities.pob.*;
import communities.sec.IPalaceSecurity;
import communities.sec.Privileged;
import communities.spb.SerialSpeech;
import communities.utl.*;
import java.applet.Applet;
import java.awt.*;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Vector;

// Referenced classes of package communities.plg:
//            IPalPresentsUI, PPPEventLeaveStage, PPPEvent, PPPEventUserEnter, 
//            PPUserRec, StageInputPanel, StagePanel, TxtChatFrm, 
//            PPPEventChatChar, PPPEventEndChat, PPPEventAskQuestion, PPPEventTalk, 
//            EventList, PPPEventNewStage, ImageButton, MessageBox, 
//            PPPEventUserList, EventListRec, PPPEventUserMove, PPPEventGotoURL, 
//            PPPEventLeaveAud, PPPEventNewModerator, PPPEventStageDesc, StageDesc, 
//            PPPEventQAPair, PPPEventStartChat, PPPEventInvite, PPPEventUserDesc, 
//            PPPEventUserColor, PPPEventUserFace, PPPEventUserName, PPPEventUserExit, 
//            PPPEventUserProp, PPPEventEnterStage, PPPEventAssetSend, PPPEventStageDown, 
//            PPPEventBadPass, PPPEventPing, PPPEventPong, PluginMgr, 
//            PalPresentsUI, JoinEventButton, PPPEventAccept, PPPEventDecline, 
//            PPPEventAskOnStage, spchDelay, PPPEventJoin, PPPEventChatResp, 
//            IPlugin, IPalacePresents, IPalPresentsEventTypes, IMessageBoxParent, 
//            PPEventBlowThru

public final class PalPresentsEventGrabber
    implements IPlugin, IPalacePresents, IPalPresentsEventTypes, IMessageBoxParent, ITxtChat, SerialSpeech, Privileged {

    private TxtChatFrm m_agChatFrame;
    private boolean m_agChatting;
    private int m_agChatterID;
    private boolean m_StageVisualNotify;
    public int m_evExRm;
    public PluginMgr m_PlugInMgr;
    PalaceCommander m_palCmdr;
    public EventList mEventList;
    public IPalaceCore mApplet;
    int m_StageID;
    int m_MyID;
    String m_MyName;
    boolean m_bUserOnStage;
    public MessageBox m_mbNotifyEvent;
    public MessageBox m_mbNotifyInvitation;
    public MessageBox m_mbNotifyOver;
    public Room2D m_StageRoom2D;
    StagePanel m_StagePanel;
    StageInputPanel m_StageInputPanel;
    Image m_JoinEventImg;
    Image m_JoinEventDownImg;
    Image m_DJoinEventImg;
    ButtonPanel joinPanel;
    public ImageButton m_JoinEventBtn;
    public IPalPresentsUI mPPUI;
    private Vector mEventLaunchQueue;
    private boolean bStageIsShowing;
    private Vector m_qaQueue;
    private Thread m_sdThread;
    private spchDelay m_sdOb;
    private transient IPalaceSecurity mSecurity;
    PalaceErrorHandler mErrorHandler;

    public void updateUserList() {
        if(mPPUI != null)
            mPPUI.updateUserList();
    }

    public void LeaveStage() {
        if(m_StageID != 0) {
            PPPEventLeaveStage pEventLeaveStage = new PPPEventLeaveStage();
            prepareAndSendPacket(pEventLeaveStage);
        }
    }

    public void UserExitedStage(PPPEventUserExit pEventUserExit) {
        String s = new String();
        s = m_StageRoom2D.getUser(((PPPEvent) (pEventUserExit)).m_userID).name + " has left the stage.";
        logText(null, s, false);
        m_StageRoom2D.removeUser(((PPPEvent) (pEventUserExit)).m_userID);
    }

    public void UserEnteredStage(PPPEventUserEnter pEventUserEnter) {
        String s = new String();
        s = pEventUserEnter.m_ppUserRec.m_PalaceUserRec.name + " is onstage.";
        logText(null, s, false);
        pEventUserEnter.m_ppUserRec.m_PalaceUserRec.userId = ((PPPEvent) (pEventUserEnter)).m_userID;
        addUser(pEventUserEnter.m_ppUserRec.m_PalaceUserRec);
    }

    public void YouAreOnStage() {
        m_bUserOnStage = true;
        m_StageInputPanel.YouAreOnStage();
        logText(null, "You are now onstage.", false);
    }

    public boolean amIonStage() {
        return m_StageID != 0 && m_bUserOnStage;
    }

    public void ShowStageUI() {
        if(m_StageInputPanel == null)
            return;
        ResourceInfo resInfo = mApplet.getResourceInfo();
        mApplet.hideUI();
        mApplet.getUI().hideTabs();
        if(resInfo.roomWindowEnabled) {
            ((Applet)mApplet).add(m_StagePanel);
            m_StagePanel.setShape();
        }
        ((Applet)mApplet).add(m_StageInputPanel);
        m_StageInputPanel.setShape();
        if(mPPUI != null)
            mPPUI.showUI();
        HideJoinButton();
        if(mApplet.getUI() != null)
            mApplet.getUI().disableNavControls();
        bStageIsShowing = true;
    }

    protected void ProcessChatCharIN(PPPEventChatChar pcc) {
        if(m_agChatting && m_agChatterID == ((PPEvent) (pcc)).refNum && m_agChatFrame != null)
            m_agChatFrame.RemStrIn(pcc.m_str);
    }

    public void EndSession() {
        if(m_agChatting || m_agChatterID > 0) {
            PPPEventEndChat ec = new PPPEventEndChat();
            prepareAndSendPacket(ec, m_agChatterID);
            m_agChatting = false;
            m_agChatterID = 0;
        }
    }

    public void AskQuestion(String strQuestion) {
        if(m_StageID != 0) {
            PPPEventAskQuestion pEventAskQuestion = new PPPEventAskQuestion(strQuestion);
            prepareAndSendPacket(pEventAskQuestion);
            String s = new String();
            s = "Question submitted: " + strQuestion;
            logText(null, s, false);
            m_StageRoom2D.roomSpeech(s, false);
        }
    }

    public void ChatOnStage(String strChatText) {
        if(m_StageID != 0) {
            PPPEventTalk pEventTalk = new PPPEventTalk(strChatText);
            prepareAndSendPacket(pEventTalk);
        }
    }

    public Room2D getRoom() {
        return m_StageRoom2D;
    }

    protected void NewStage(PPPEventNewStage pNewStage, boolean visualNotify) {
        if(visualNotify && !mApplet.getAppletStatus().introInProgress) {
            m_StageVisualNotify = true;
            NewStage(pNewStage);
        } else {
            EventListRec evtListRec = mEventList.findEvent(((PPEvent) (pNewStage)).refNum);
            if(evtListRec == null) {
                mEventList.add(pNewStage.m_eventName, pNewStage.m_eventInfoURL, ((PPEvent) (pNewStage)).refNum, false);
                checkEventLaunchQueue(pNewStage);
            }
            if(mApplet.getResourceInfo().eventsPanelEnabled)
                mApplet.getUI().selectEvent(mEventList.getEventCount() - 1);
        }
    }

    public void NewStage(PPPEventNewStage pNewStage) {
        EventListRec evtListRec = mEventList.findEvent(((PPEvent) (pNewStage)).refNum);
        if(evtListRec == null) {
            mEventList.add(pNewStage.m_eventName, pNewStage.m_eventInfoURL, ((PPEvent) (pNewStage)).refNum, true);
            if(mApplet.getResourceInfo().eventsPanelEnabled)
                mApplet.getUI().selectEvent(mEventList.getEventCount() - 1);
            evtListRec = mEventList.findEvent(((PPEvent) (pNewStage)).refNum);
        }
        CheckForEvents();
        if(evtListRec != null)
            PromptToJoinEvent(evtListRec);
    }

    public void reshapeTextInput() {
        java.awt.TextField textInput = mApplet.getTextInput();
        ResourceInfo resInfo = mApplet.getResourceInfo();
        if(mEventList != null) {
            if(mEventList.getEventCount() >= 1) {
                Dimension dm = m_JoinEventBtn.preferredSize();
                textInput.reshape(resInfo.textInputRect.x, resInfo.textInputRect.y, resInfo.textInputRect.width - dm.width - 4, resInfo.textInputRect.height);
            } else {
                textInput.reshape(resInfo.textInputRect.x, resInfo.textInputRect.y, resInfo.textInputRect.width, resInfo.textInputRect.height);
            }
        } else {
            textInput.reshape(resInfo.textInputRect.x, resInfo.textInputRect.y, resInfo.textInputRect.width, resInfo.textInputRect.height);
        }
    }

    protected void checkEventLaunchQueue(PPPEventNewStage pNewStage) {
        if(mEventLaunchQueue.size() > 0) {
            for(int i = 0; i < mEventLaunchQueue.size(); i++)
                if(pNewStage.m_eventName.compareTo((String)mEventLaunchQueue.elementAt(i)) == 0) {
                    mEventLaunchQueue.removeElementAt(i);
                    JoinEvent(((PPEvent) (pNewStage)).refNum);
                }

        }
    }

    public void ProcessStageDown(PPPEventStageDown pEventStageDown) {
        mEventList.remove(((PPEvent) (pEventStageDown)).refNum);
        m_StageVisualNotify = mEventList.visualNotifyEventsAvail();
        CheckForEvents();
        if(m_StageID == ((PPEvent) (pEventStageDown)).refNum) {
            m_mbNotifyOver = new MessageBox(this, mApplet.getAppletFrame(), "PalacePresents Event Over", "This PalacePresents event is over.\nThank you for attending.\n", 1, null);
            m_mbNotifyOver.show();
            logText(null, "The event has ended.\n", false);
        }
        clearQAQueue();
    }

    public void ProcessUserList(PPPEventUserList pEventUserList) {
        int userCnt = pEventUserList.m_userCnt;
        String s = new String();
        if(userCnt > 1)
            s = "There are " + userCnt + " people on the stage.";
        else
        if(userCnt == 1)
            s = "There is " + userCnt + " person on the stage.";
        else
            s = "There is nobody on the stage.";
        logText(null, s, false);
        m_StageRoom2D.clearUsers();
        for(int i = 0; i < pEventUserList.m_userCnt; i++) {
            PPUserRec ppUserRec = pEventUserList.m_ppUserRecArray[i];
            UserRec ur = ppUserRec.m_PalaceUserRec;
            addUser(ur);
        }

        m_StageRoom2D.CheckUserProps();
    }

    public void ReceivedPong() {
    }

    public void PromptToJoinEvent(EventListRec evtListRec) {
        if(m_StageID == 0)
            if(m_mbNotifyEvent == null) {
                if(!evtListRec.getUserpromptedFlag()) {
                    String strMsg = "The PalacePresents Event\n\"" + evtListRec.m_eventName + "\" is in progress.\n\nWould you like to join it?\n";
                    m_mbNotifyEvent = new MessageBox(this, mApplet.getAppletFrame(), "PalacePresents Event In Progress", strMsg, 12, evtListRec);
                    m_mbNotifyEvent.show();
                }
            } else {
                m_mbNotifyEvent.toFront();
                m_mbNotifyEvent.show();
            }
    }

    private void clearQAQueue() {
        synchronized(m_qaQueue) {
            m_qaQueue.removeAllElements();
        }
    }

    public void MoveSelf(int x, int y) {
        if(m_StageID != 0) {
            m_StageRoom2D.moveUser(((Room) (m_StageRoom2D)).userID, x, y);
            PPPEventUserMove um = new PPPEventUserMove(x, y);
            prepareAndSendPacket(um);
        }
    }

    public void shutDownMessageBoxes() {
        if(m_mbNotifyEvent != null)
            m_mbNotifyEvent.hide();
        if(m_mbNotifyInvitation != null)
            m_mbNotifyInvitation.hide();
    }

    public void GotoURL(PPPEventGotoURL pEventGotoURL) {
        if(pEventGotoURL.getPopup() == 1) {
            String s = new String();
            s = "PRIVATE ANSWER URL " + pEventGotoURL.getURL();
            logText(null, s, false);
            mApplet.gotoURL(pEventGotoURL.getURL(), "_blank");
        } else {
            String s = new String();
            s = "Showing URL " + pEventGotoURL.getURL();
            logText(null, s, false);
            mApplet.gotoURL(pEventGotoURL.getURL(), "PPSlideShow");
        }
    }

    public void LeaveAudience() {
        if(m_StageID != 0) {
            PPPEventLeaveAud pEventLeaveAud = new PPPEventLeaveAud();
            prepareAndSendPacket(pEventLeaveAud);
        }
    }

    public boolean isStageShowing() {
        return bStageIsShowing;
    }

    protected void ProcessNewModerator(PPPEventNewModerator newMod) {
        int newID = newMod.getNewModID();
        int oldID = newMod.getOldModID();
        EventListRec evtListRec = mEventList.findEvent(oldID);
        if(evtListRec == null)
            return;
        evtListRec.m_stageID = newID;
        if(m_StageID == oldID)
            m_StageID = newID;
    }

    public void destroy() {
        shutDown(true);
        clearEventList();
        HideJoinButton();
        if(m_sdThread != null) {
            m_sdThread.stop();
            m_sdThread = null;
        }
    }

    public void ProcessStageDesc(PPPEventStageDesc pEventStageDesc) {
        StageDesc stageDesc = pEventStageDesc.getStageDesc();
        ResourceInfo resInfo = mApplet.getResourceInfo();
        logText(null, "Welcome to the PalacePresents Event.", false);
        if(resInfo.roomWindowEnabled)
            m_StagePanel.StageDesc(stageDesc);
        m_StageInputPanel.StageDesc(stageDesc);
        if(stageDesc.m_MediaURL.length() > 0)
            mApplet.gotoURL(stageDesc.m_MediaURL, "PPMediaURL");
    }

    public PPEvent getIncomingData(PPEventBlowThru ppEvtBlowThru, NetDataInputStream ndis) throws IOException {
        boolean bigEndian = false;
        if(ndis.isBigEndian()) {
            ndis.setBigEndian(false);
            bigEndian = true;
        }
        PPPEvent pppEvent = new PPPEvent(ppEvtBlowThru);
        pppEvent.read(ndis);
        PPPEvent p;
        switch(pppEvent.m_AudCommand) {
        case 56: // '8'
            p = new PPPEventQAPair(pppEvent);
            break;

        case 37: // '%'
            p = new PPPEventNewModerator(pppEvent);
            break;

        case 50: // '2'
            p = new PPPEventStartChat(pppEvent);
            break;

        case 52: // '4'
            p = new PPPEventEndChat(pppEvent);
            break;

        case 53: // '5'
            p = new PPPEventChatChar(pppEvent);
            break;

        case 3: // '\003'
            p = new PPPEventInvite(pppEvent);
            break;

        case 6: // '\006'
            p = new PPPEventTalk(pppEvent);
            break;

        case 9: // '\t'
            p = new PPPEventGotoURL(pppEvent);
            break;

        case 19: // '\023'
            p = new PPPEventUserDesc(pppEvent);
            break;

        case 10: // '\n'
            p = new PPPEventUserMove(pppEvent);
            break;

        case 11: // '\013'
            p = new PPPEventUserColor(pppEvent);
            break;

        case 12: // '\f'
            p = new PPPEventUserFace(pppEvent);
            break;

        case 13: // '\r'
            p = new PPPEventUserName(pppEvent);
            break;

        case 14: // '\016'
            p = new PPPEventStageDesc(pppEvent);
            break;

        case 18: // '\022'
            p = new PPPEventNewStage(pppEvent);
            break;

        case 20: // '\024'
            p = new PPPEventUserList(pppEvent);
            break;

        case 21: // '\025'
            p = new PPPEventUserEnter(pppEvent);
            break;

        case 22: // '\026'
            p = new PPPEventUserExit(pppEvent);
            break;

        case 23: // '\027'
            p = new PPPEventUserProp(pppEvent);
            break;

        case 25: // '\031'
            p = new PPPEventLeaveStage(pppEvent);
            break;

        case 26: // '\032'
            p = new PPPEventEnterStage(pppEvent);
            break;

        case 28: // '\034'
            p = new PPPEventAssetSend(pppEvent);
            break;

        case 29: // '\035'
            p = new PPPEventStageDown(pppEvent);
            break;

        case 30: // '\036'
            p = new PPPEventBadPass(pppEvent);
            break;

        case 31: // '\037'
            p = new PPPEventPing(pppEvent);
            break;

        case 32: // ' '
            p = new PPPEventPong(pppEvent);
            break;

        default:
            p = new PPPEvent(pppEvent);
            mErrorHandler.reportError("bogus PPPEvent", 1);
            break;
        }
        p.read(ndis);
        if(bigEndian)
            ndis.setBigEndian(true);
        return p;
    }

    public void prepareAndSendPacket(PPPEvent p) {
        m_MyID = m_palCmdr.pc_GetUserID();
        p.SetUserID(m_MyID);
        p.SetStageUserID(m_StageID);
        m_PlugInMgr.sendBlowThruEvent(p);
    }

    public void messageBoxDismissed(MessageBox mbDlg) {
        int resp = mbDlg.getResponse();
        if(mbDlg == m_mbNotifyEvent) {
            EventListRec evtListRec = (EventListRec)m_mbNotifyEvent.getUserData();
            if(evtListRec != null) {
                if(resp == 4)
                    JoinEvent(evtListRec.m_stageID, "");
                evtListRec.setUserpromptedFlag();
            }
            m_mbNotifyEvent.hide();
            m_mbNotifyEvent = null;
        } else
        if(mbDlg == m_mbNotifyInvitation) {
            PPPEventInvite pEventInvite = (PPPEventInvite)m_mbNotifyInvitation.getUserData();
            if(pEventInvite != null)
                if(resp == 4)
                    AcceptInvitation(pEventInvite);
                else
                    DeclineInvitation(pEventInvite);
            m_mbNotifyInvitation.hide();
            m_mbNotifyInvitation = null;
        } else
        if(mbDlg == m_mbNotifyOver) {
            m_mbNotifyOver.hide();
            shutDown();
            m_mbNotifyOver = null;
        } else {
            mErrorHandler.reportError("unknown message box", 1);
            mbDlg.hide();
        }
    }

    public void prepareAndSendPacket(PPPEvent p, int sendToUserID) {
        m_MyID = m_palCmdr.pc_GetUserID();
        p.SetUserID(m_MyID);
        p.SetStageUserID(sendToUserID);
        m_PlugInMgr.sendBlowThruEvent(p);
    }

    public void InitStageUI() {
        ResourceInfo resInfo = mApplet.getResourceInfo();
        m_StageRoom2D = new Room2D(mApplet, 0);
        m_palCmdr = new StageCommander(mApplet, this);
        m_StageRoom2D.setPropTable(mApplet.getPropTable());
        m_StageRoom2D.setPalaceCommander(m_palCmdr);
        m_palCmdr.setRoom(m_StageRoom2D);
        m_palCmdr.setScriptManager(mApplet.getScriptMgr());
        if(m_palCmdr != null) {
            m_MyID = mApplet.getPalaceCommander().pc_GetUserID();
            m_MyName = mApplet.getPalaceCommander().pc_GetUserName();
        }
        m_StageRoom2D.setUserID(m_MyID);
        m_StageRoom2D.setName(m_MyName);
        if(resInfo.roomWindowEnabled) {
            m_StagePanel = new StagePanel(this, resInfo);
            m_StagePanel.setSecurity(mSecurity);
            m_StagePanel.setLayout(null);
            m_StagePanel.reshape(resInfo.roomWindowRect.x, resInfo.roomWindowRect.y, resInfo.roomWindowRect.width, resInfo.roomWindowRect.height);
            m_StagePanel.Init(m_StageRoom2D);
        }
        if(resInfo.PPTabPanelEnabled) {
            PalPresentsUI aPPUI = new PalPresentsUI(mApplet);
            aPPUI.setSecurity(mSecurity);
            mPPUI = aPPUI;
            mPPUI.initUI();
        }
        m_StageInputPanel = new StageInputPanel(this, resInfo);
        m_StageInputPanel.setSecurity(mSecurity);
        m_StageInputPanel.setLayout(null);
        m_StageInputPanel.reshape(resInfo.textInputRect.x, resInfo.textInputRect.y, resInfo.textInputRect.width, resInfo.textInputRect.height + 16);
        m_StageInputPanel.Init();
        String appdataFolder = getAppletDataFolder();
        appdataFolder += "resource/";
        try {
            PalPresentsEventGrabber$ImageGetter getter = new PalPresentsEventGrabber$ImageGetter(this, appdataFolder);
            URL aURL = new URL(appdataFolder + "join-up.gif");
            mSecurity.connectTo(aURL, getter);
        }
        catch(MalformedURLException mfu) {
            if(mErrorHandler != null)
                mErrorHandler.reportError("Bad URL: " + mfu.getMessage(), 1);
        }
        catch(SecurityException e) {
            if(mErrorHandler != null)
                mErrorHandler.reportError("Security Exception: " + e.getMessage(), 1);
        }
        m_JoinEventBtn = new JoinEventButton(this, m_JoinEventImg, m_JoinEventDownImg, m_DJoinEventImg, 72, 34, 0);
        m_JoinEventBtn.setBkMode(true);
        m_JoinEventBtn.resize(m_JoinEventBtn.preferredSize().width + 4, m_JoinEventBtn.preferredSize().height);
        joinPanel = new ButtonPanel(1, mApplet);
        joinPanel.resize(m_JoinEventBtn.preferredSize());
        joinPanel.addButton(m_JoinEventBtn, "Join Event");
        m_JoinEventBtn.move(4, 0);
    }

    public void HideStageUI() {
        if(m_StageInputPanel == null)
            return;
        ResourceInfo resInfo = mApplet.getResourceInfo();
        if(resInfo.roomWindowEnabled)
            ((Applet)mApplet).remove(m_StagePanel);
        CheckForEvents();
        if(resInfo.roomWindowEnabled)
            ((Applet)mApplet).remove(m_StagePanel);
        ((Applet)mApplet).remove(m_StageInputPanel);
        if(mPPUI != null)
            mPPUI.hideUI();
        mApplet.showUI();
        mApplet.getUI().showTabs();
        if(mApplet.getUI() != null)
            mApplet.getUI().updateNavControls();
        bStageIsShowing = false;
    }

    public String getAppletDataFolder() {
        return mApplet.getResourceInfo().getAppletDataFolder();
    }

    public void ProcessQAPair(PPPEventQAPair qap) {
        synchronized(m_qaQueue) {
            m_qaQueue.addElement(qap);
            int queueSize = m_qaQueue.size();
            if(queueSize == 1)
                displayQAPair(qap);
        }
    }

    public void CheckForEvents() {
        if(mEventList.getEventCount() >= 1 && m_StageID == 0 && m_StageVisualNotify)
            ShowJoinButton();
        else
            HideJoinButton();
    }

    public void AcceptInvitation(PPPEventInvite pEventInvite) {
        if(m_StageID != 0) {
            PPPEventAccept pEventAccept = new PPPEventAccept();
            UserRec MyUserRec = mApplet.getPalaceCommander().pc_GetUserRec(0);
            pEventAccept.setUserRec(MyUserRec);
            prepareAndSendPacket(pEventAccept);
        }
    }

    public void DeclineInvitation(PPPEventInvite pEventInvite) {
        if(m_StageID != 0) {
            PPPEventDecline pEventDecline = new PPPEventDecline();
            prepareAndSendPacket(pEventDecline);
        }
    }

    public void PromptInvitation(PPPEventInvite pEventInvite) {
        if(m_mbNotifyInvitation == null) {
            m_mbNotifyInvitation = new MessageBox(this, mApplet.getAppletFrame(), "PalacePresents Onstage Invitation", "You have been invited onstage.\n\nAccept?\n", 12, pEventInvite);
            m_mbNotifyInvitation.show();
        } else {
            m_mbNotifyInvitation.toFront();
            m_mbNotifyInvitation.show();
        }
    }

    public void ShowJoinButton() {
        ResourceInfo resInfo = mApplet.getResourceInfo();
        Dimension dm = m_JoinEventBtn.preferredSize();
        java.awt.TextField textInput = mApplet.getTextInput();
        if(mApplet.getChatLabel() != null)
            textInput.reshape(resInfo.textInputRect.x + 158, resInfo.textInputRect.y, resInfo.textInputRect.width - 158 - dm.width - 4, resInfo.textInputRect.height);
        else
            textInput.reshape(resInfo.textInputRect.x, resInfo.textInputRect.y, resInfo.textInputRect.width - dm.width - 4, resInfo.textInputRect.height);
        if(resInfo.statusLabelEnabled)
            mApplet.getStatusLabel().resize(resInfo.statusLabelRect.width - dm.width - 4, resInfo.statusLabelRect.height);
        ((Applet)mApplet).add(joinPanel);
        joinPanel.reshape(resInfo.textInputRect.width - dm.width - 4, resInfo.textInputRect.y, dm.width + 4, dm.height);
        joinPanel.show();
        joinPanel.reset();
    }

    public void doneSpch() {
        synchronized(m_sdOb) {
            m_sdOb.notify();
        }
    }

    protected void ProcessChatCharOUT(String str) {
        if(m_agChatting && m_agChatterID > 0) {
            PPPEventChatChar cc = new PPPEventChatChar(str);
            prepareAndSendPacket(cc, m_agChatterID);
        }
    }

    public void displayQAPair(PPPEventQAPair qap) {
        User quesUser = m_StageRoom2D.getUser(qap.m_quesID);
        User ansUser = m_StageRoom2D.getUser(qap.m_ansID);
        if(qap.m_quesID == -1) {
            m_StageRoom2D.roomSpeech(qap.m_ques, false, qap.m_delay, null);
            logText(null, qap.m_ques, false);
        } else
        if(quesUser != null) {
            m_StageRoom2D.userSpeech(qap.m_quesID, qap.m_ques, false, qap.m_delay, null);
            logText(quesUser, qap.m_ques, false);
        }
        if(qap.m_ansID == -1 || ansUser == null) {
            m_StageRoom2D.roomSpeech(qap.m_ans, false, qap.m_delay, this);
            logText(null, qap.m_ans, false);
        } else {
            m_StageRoom2D.userSpeech(qap.m_ansID, qap.m_ans, false, qap.m_delay, this);
            logText(ansUser, qap.m_ans, false);
        }
    }

    public Vector getQAQueue() {
        return m_qaQueue;
    }

    public void EventInfo() {
        mApplet.gotoURL(mEventList.getSelectedEvent().m_eventInfoURL, "Event Info");
    }

    public void UserMove(PPPEventUserMove pEventUserMove) {
        m_StageRoom2D.moveUser(((PPPEvent) (pEventUserMove)).m_userID, pEventUserMove.m_x, pEventUserMove.m_y);
    }

    public boolean processPPEvent(PPEvent ppEvent) {
        return true;
    }

    public void SendStr(String str) {
        ProcessChatCharOUT(str);
    }

    public void UserDesc(PPPEventUserDesc pppeventuserdesc) {
    }

    protected void ProcessEndChat(PPPEventEndChat pec) {
        if(m_agChatterID != 0 && m_agChatterID == ((PPEvent) (pec)).refNum) {
            m_agChatting = false;
            m_agChatterID = 0;
            TxtChatFrm f = m_agChatFrame;
            m_agChatFrame = null;
            f.m_RemEndSess = true;
            f.dispose();
        }
    }

    public void UserName(PPPEventUserName pppeventusername) {
    }

    public void clearEventList() {
        if(mEventList != null)
            mEventList.clear();
    }

    public void AskOnStage() {
        if(m_StageID != 0) {
            PPPEventAskOnStage pEventAskOnStage = new PPPEventAskOnStage();
            prepareAndSendPacket(pEventAskOnStage);
            logText(null, "Your request to go onstage has been submitted.", true);
            m_StageRoom2D.roomSpeech("Your request to go onstage has been submitted.", false);
        }
    }

    public void YouAreOffStage() {
        m_bUserOnStage = false;
        m_StageInputPanel.YouAreOffStage();
        logText(null, "You have left the stage.", false);
    }

    public void shutDown() {
        shutDown(true);
    }

    public void shutDown(boolean bConnectedToServer) {
        if(m_StageID != 0) {
            if(amIonStage() && bConnectedToServer)
                LeaveStage();
            YouAreOffStage();
            if(bConnectedToServer)
                LeaveAudience();
            m_StageID = 0;
            HideStageUI();
        }
        clearQAQueue();
    }

    public String getPicFolder() {
        return mApplet.getResourceInfo().getPicFolder();
    }

    public void HideJoinButton() {
        ResourceInfo resInfo = mApplet.getResourceInfo();
        joinPanel.reset();
        ((Applet)mApplet).remove(joinPanel);
        java.awt.TextField textInput = mApplet.getTextInput();
        if(mApplet.getChatLabel() != null)
            textInput.reshape(resInfo.textInputRect.x + 158, resInfo.textInputRect.y, resInfo.textInputRect.width - 158, resInfo.textInputRect.height);
        else
            textInput.reshape(resInfo.textInputRect.x, resInfo.textInputRect.y, resInfo.textInputRect.width, resInfo.textInputRect.height);
        if(resInfo.statusLabelEnabled)
            mApplet.getStatusLabel().resize(resInfo.statusLabelRect.width, resInfo.statusLabelRect.height);
    }

    public void SendPong() {
        if(m_StageID != 0) {
            PPPEventPong pEventPong = new PPPEventPong();
            prepareAndSendPacket(pEventPong);
        }
    }

    public boolean processBlowThruEvent(PPEvent ppEvent) {
        PPPEvent pppEvent = (PPPEvent)ppEvent;
        switch(pppEvent.m_AudCommand) {
        default:
            break;

        case 56: // '8'
            PPPEventQAPair qap = (PPPEventQAPair)pppEvent;
            ProcessQAPair(qap);
            qap = null;
            break;

        case 50: // '2'
            PPPEventStartChat psc = (PPPEventStartChat)pppEvent;
            ProcessStartChat(psc);
            psc = null;
            break;

        case 52: // '4'
            PPPEventEndChat pce = (PPPEventEndChat)pppEvent;
            ProcessEndChat(pce);
            pce = null;
            break;

        case 53: // '5'
            PPPEventChatChar pcc = (PPPEventChatChar)pppEvent;
            ProcessChatCharIN(pcc);
            pcc = null;
            break;

        case 37: // '%'
            PPPEventNewModerator pnm = (PPPEventNewModerator)pppEvent;
            ProcessNewModerator(pnm);
            pnm = null;
            break;

        case 18: // '\022'
            PPPEventNewStage pNewStage = (PPPEventNewStage)pppEvent;
            if(pNewStage.getVisualNotify() == 1)
                NewStage(pNewStage, true);
            else
                NewStage(pNewStage, false);
            break;

        case 14: // '\016'
            PPPEventStageDesc pEventStageDesc = (PPPEventStageDesc)pppEvent;
            ProcessStageDesc(pEventStageDesc);
            break;

        case 3: // '\003'
            PPPEventInvite pEventInvite = (PPPEventInvite)pppEvent;
            PromptInvitation(pEventInvite);
            break;

        case 6: // '\006'
            PPPEventTalk pEventTalk = (PPPEventTalk)pppEvent;
            InChat(pEventTalk);
            break;

        case 20: // '\024'
            PPPEventUserList pEventUserList = (PPPEventUserList)pppEvent;
            ProcessUserList(pEventUserList);
            break;

        case 21: // '\025'
            PPPEventUserEnter pEventUserEnter = (PPPEventUserEnter)pppEvent;
            UserEnteredStage(pEventUserEnter);
            break;

        case 22: // '\026'
            PPPEventUserExit pEventUserExit = (PPPEventUserExit)pppEvent;
            UserExitedStage(pEventUserExit);
            break;

        case 25: // '\031'
            PPPEventLeaveStage pEventLeaveStage = (PPPEventLeaveStage)pppEvent;
            YouAreOffStage();
            break;

        case 26: // '\032'
            PPPEventEnterStage pEventEnterStage = (PPPEventEnterStage)pppEvent;
            YouAreOnStage();
            break;

        case 29: // '\035'
            PPPEventStageDown pEventStageDown = (PPPEventStageDown)pppEvent;
            ProcessStageDown(pEventStageDown);
            break;

        case 30: // '\036'
            PPPEventBadPass pEventBadPass = (PPPEventBadPass)pppEvent;
            BadPassword(pEventBadPass);
            break;

        case 31: // '\037'
            PPPEventPing pEventPing = (PPPEventPing)pppEvent;
            SendPong();
            break;

        case 32: // ' '
            PPPEventPong pEventPong = (PPPEventPong)pppEvent;
            ReceivedPong();
            break;

        case 9: // '\t'
            PPPEventGotoURL pEventGotoURL = (PPPEventGotoURL)pppEvent;
            GotoURL(pEventGotoURL);
            break;

        case 19: // '\023'
            PPPEventUserDesc pEventUserDesc = (PPPEventUserDesc)pppEvent;
            UserDesc(pEventUserDesc);
            break;

        case 10: // '\n'
            PPPEventUserMove pEventUserMove = (PPPEventUserMove)pppEvent;
            UserMove(pEventUserMove);
            break;

        case 11: // '\013'
            PPPEventUserColor pEventUserColor = (PPPEventUserColor)pppEvent;
            UserColor(pEventUserColor);
            break;

        case 12: // '\f'
            PPPEventUserFace pEventUserFace = (PPPEventUserFace)pppEvent;
            UserFace(pEventUserFace);
            break;

        case 13: // '\r'
            PPPEventUserName pEventUserName = (PPPEventUserName)pppEvent;
            UserName(pEventUserName);
            break;
        }
        return true;
    }

    public void JoinEvent() {
        EventListRec evtListRec = mEventList.getSelectedEvent();
        if(evtListRec != null)
            JoinEvent(evtListRec.m_stageID);
    }

    public void JoinEvent(int stageID) {
        JoinEvent(stageID, "");
    }

    public void JoinEvent(String eventName) {
        EventListRec evtListRec = mEventList.findEvent(eventName);
        if(evtListRec != null) {
            JoinEvent(evtListRec.m_stageID);
        } else {
            if(mEventLaunchQueue == null)
                mEventLaunchQueue = new Vector();
            mEventLaunchQueue.addElement(eventName);
        }
    }

    public PalPresentsEventGrabber(PluginMgr PlugInMgr, IPalaceSecurity aSecurity) {
        m_agChatFrame = null;
        m_agChatting = false;
        m_agChatterID = 0;
        m_StageVisualNotify = false;
        m_evExRm = 0;
        m_PlugInMgr = null;
        m_palCmdr = null;
        mEventList = null;
        mApplet = null;
        m_StageID = 0;
        m_MyID = 0;
        m_MyName = null;
        m_bUserOnStage = false;
        m_mbNotifyEvent = null;
        m_mbNotifyInvitation = null;
        m_mbNotifyOver = null;
        m_StageRoom2D = null;
        m_StagePanel = null;
        m_StageInputPanel = null;
        m_JoinEventImg = null;
        m_JoinEventDownImg = null;
        m_DJoinEventImg = null;
        joinPanel = null;
        m_JoinEventBtn = null;
        mPPUI = null;
        mEventLaunchQueue = null;
        bStageIsShowing = false;
        m_qaQueue = null;
        m_sdThread = null;
        m_sdOb = null;
        m_PlugInMgr = PlugInMgr;
        mSecurity = aSecurity;
        if(m_PlugInMgr != null) {
            mApplet = m_PlugInMgr.getPalaceApplet();
            if(mApplet.getUI() != null)
                mEventList = new EventList(mApplet.getUI().getEventList());
            else
                mEventList = new EventList(null);
            InitStageUI();
            mErrorHandler = mApplet.getErrorHandler();
        }
        m_qaQueue = new Vector(50, 10);
        mEventLaunchQueue = new Vector();
        m_sdOb = new spchDelay(this);
        m_sdThread = new Thread(m_sdOb, "SpeechDelay");
        try {
            m_sdThread.setDaemon(true);
        }
        catch(Exception e) { }
        m_sdThread.start();
    }

    public void JoinEvent(int stageID, String Password) {
        if(m_StageID != 0) {
            if(m_StageID == stageID)
                return;
            shutDown();
            logText(null, "Exiting the event\n", false);
        }
        shutDownMessageBoxes();
        if(m_StageID == 0) {
            m_MyID = mApplet.getPalaceCommander().pc_GetUserID();
            m_MyName = mApplet.getPalaceCommander().pc_GetUserName();
            m_StageRoom2D.setUserID(m_MyID);
            m_StageRoom2D.setName(m_MyName);
            UserRec MyUserRec = mApplet.getPalaceCommander().pc_GetUserRec(0);
            if(MyUserRec == null)
                return;
            m_StageID = stageID;
            PPPEventJoin pEventJoin = new PPPEventJoin();
            pEventJoin.setUserRecPassword(MyUserRec, Password);
            prepareAndSendPacket(pEventJoin);
            mEventList.setLastAttendedEvent(m_StageID);
            ShowStageUI();
        }
    }

    public void JoinDefaultEvent() {
        EventListRec evtListRec = mEventList.getDefaultEvent();
        if(evtListRec != null)
            JoinEvent(evtListRec.m_stageID, "");
    }

    public void UserColor(PPPEventUserColor pEventUserColor) {
        m_StageRoom2D.setUserColorNbr(((PPPEvent) (pEventUserColor)).m_userID, pEventUserColor.m_colorNbr);
    }

    public void checkUserProps() {
        if(m_StageRoom2D != null)
            m_StageRoom2D.CheckUserProps();
    }

    protected void logText(User u, String msg, boolean privateFlag) {
        if(mPPUI != null) {
            ResourceInfo resInfo = mApplet.getResourceInfo();
            if(resInfo.PPTranscriptPanelEnabled)
                mPPUI.logText(u, msg, privateFlag);
        }
    }

    public void BadPassword(PPPEventBadPass pppeventbadpass) {
    }

    protected void finalize() {
        destroy();
        m_sdOb = null;
        m_sdThread = null;
        m_qaQueue = null;
    }

    public void addUser(UserRec ur) {
        int x = ur.x;
        int y = ur.y;
        if(x < 0 || x > 512)
            x = 256;
        if(y < 0 || y > 384)
            y = 192;
        User2D user2D = new User2D(m_StageRoom2D, ur.name, ur.userId, x, y, ur.roomId, ur.faceNumber, ur.colorNumber, ur.awayFlag, ur.openToMsgs, ur.numberProps, ur.propIDs, ur.propCRCs);
        m_StageRoom2D.addUser(user2D);
    }

    public void InChat(PPPEventTalk pEventTalk) {
        String s = pEventTalk.m_ChatTxt;
        s = "" + pEventTalk.m_ChatTxt + "\n";
        if(((PPPEvent) (pEventTalk)).m_userID == -1) {
            logText(null, s, false);
            m_StageRoom2D.roomSpeech(s, false, pEventTalk.m_delayLen);
        } else {
            User u = m_StageRoom2D.getUser(((PPPEvent) (pEventTalk)).m_userID);
            if(u != null)
                m_StageRoom2D.userSpeech(((PPPEvent) (pEventTalk)).m_userID, s, false, pEventTalk.m_delayLen);
            else
                m_StageRoom2D.roomSpeech(s, false, pEventTalk.m_delayLen);
            logText(u, s, false);
        }
    }

    protected void ProcessStartChat(PPPEventStartChat psc) {
        if(m_agChatting) {
            PPPEventChatResp cr = new PPPEventChatResp((byte)0);
            prepareAndSendPacket(cr, ((PPEvent) (psc)).refNum);
        } else {
            m_agChatting = true;
            m_agChatterID = ((PPEvent) (psc)).refNum;
            String locUserName = mApplet.getPalaceCommander().pc_GetUserName(m_MyID);
            m_agChatFrame = new TxtChatFrm("Whispering with Agent...\r\n", "Event Moderator", (byte)1, locUserName, this);
            PPPEventChatResp cr = new PPPEventChatResp((byte)1);
            prepareAndSendPacket(cr, ((PPEvent) (psc)).refNum);
        }
    }

    public void UserFace(PPPEventUserFace pEventUserFace) {
        m_StageRoom2D.setUserFaceNbr(((PPPEvent) (pEventUserFace)).m_userID, pEventUserFace.m_faceNbr);
    }
}
