// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 14:53:14 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.plg;

import communities.LogArea;
import communities.pob.ITxtChat;
import java.awt.*;

public class TxtChatFrm extends Frame {

    public boolean m_RemEndSess;
    public String m_locName;
    private LogArea m_LocArea;
    private LogArea m_RemArea;
    private ITxtChat m_chatImpl;

    public TxtChatFrm(String greeting, String title, byte type, String localUserName, ITxtChat chatImpl) {
        this(title, type, localUserName, chatImpl);
        m_RemArea.appendText(greeting);
    }

    public TxtChatFrm(String title, byte type, String localUserName, ITxtChat chatImpl) {
        super(title);
        m_RemEndSess = false;
        m_locName = null;
        m_LocArea = null;
        m_RemArea = null;
        m_chatImpl = null;
        m_chatImpl = chatImpl;
        if(localUserName != null)
            m_locName = localUserName;
        else
            m_locName = "";
        switch(type) {
        case 1: // '\001'
            InitTwoWayFrm();
            break;

        default:
            InitTwoWayFrm();
            break;
        }
    }

    private void InitTwoWayFrm() {
        m_RemArea = new LogArea(false, Color.lightGray, 500, 460);
        m_LocArea = new LogArea(true, Color.white, 500, 40);
        setLayout(new BorderLayout());
        add("South", m_LocArea);
        add("Center", m_RemArea);
        reshape(25, 25, 500, 200);
        show();
        m_LocArea.requestFocus();
        m_LocArea.setText("<TYPE HERE TO START CHATTING>");
        m_LocArea.selectAll();
    }

    public void RemStrIn(String str) {
        m_RemArea.appendText(str + "\r\n---\r\n");
    }

    public void dispose() {
        if(!m_RemEndSess)
            m_chatImpl.EndSession();
        super.dispose();
    }

    public boolean handleEvent(Event evt) {
        if(evt.id == 201) {
            m_RemEndSess = false;
            dispose();
        }
        return super.handleEvent(evt);
    }

    public boolean keyDown(Event evt, int key) {
        boolean ret = false;
        if(evt.target == m_LocArea && (evt.id == 401 || evt.id == 402) && key == 10) {
            String str = m_LocArea.getText();
            if(str.length() > 0) {
                m_chatImpl.SendStr(m_locName + ": " + str);
                m_LocArea.setText("");
                m_RemArea.appendText(m_locName + ": " + str + "\r\n---\r\n");
                ret = true;
            }
        }
        return ret;
    }
}
