// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 15:04:52 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.pob;

import communities.IPalaceCore;
import communities.pkt.PPEventAssetQuery;
import communities.pkt.PPEventAssetSend;
import java.io.*;
import java.util.Hashtable;

// Referenced classes of package communities.pob:
//            PalaceProp

public class PropTable extends Hashtable {

    IPalaceCore itsCore;
    int userID;
    private String myCachePath;

    public void ProvideUserID(int userID) {
        this.userID = userID;
    }

    public PropTable(IPalaceCore itsCore) {
        this.itsCore = null;
        userID = 0;
        myCachePath = null;
        this.itsCore = itsCore;
    }

    public void done() {
        itsCore = null;
    }

    public void PropFulfillment(PPEventAssetSend ab) {
        if(ab.assetType == 0x50726f70) {
            Integer key = new Integer(ab.assetID);
            PalaceProp prop = (PalaceProp)remove(key);
            try {
                if(myCachePath.length() > 0) {
                    FileOutputStream fos = new FileOutputStream(myCachePath + Integer.toHexString(ab.assetID) + ".jif");
                    prop.Fulfill(ab, new DataOutputStream(fos));
                    fos.close();
                } else {
                    prop.Fulfill(ab, null);
                }
            }
            catch(Exception e) {
                if(prop != null)
                    prop.Fulfill(ab, null);
            }
        }
    }

    public PalaceProp PropReference(int id, int crc) {
        Integer key = new Integer(id);
        PalaceProp prop = (PalaceProp)get(key);
        if(prop == null) {
            prop = new PalaceProp(id, crc);
            try {
                if(myCachePath.length() > 0) {
                    File f = new File(myCachePath + Integer.toHexString(id) + ".jif");
                    FileInputStream fis = new FileInputStream(f);
                    prop.Fulfill(new DataInputStream(fis));
                    fis.close();
                } else {
                    put(key, prop);
                    itsCore.sendPPEvent(new PPEventAssetQuery(userID, 0x50726f70, id, crc));
                }
            }
            catch(Exception e) {
                put(key, prop);
                itsCore.sendPPEvent(new PPEventAssetQuery(userID, 0x50726f70, id, crc));
            }
        }
        return prop;
    }
}
