// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 15:04:52 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.pob;

import communities.spb.SerialSpeech;

// Referenced classes of package communities.pob:
//            PalaceProp, PropTable

public class User {

    public int x;
    public int y;
    int faceNbr;
    int colorNbr;
    int numberProps;
    public String name;
    public int id;
    int propIDs[];
    int propCRCs[];
    boolean propUnfulfilled[];
    PalaceProp pprops[];
    boolean hideFaceFlag;
    public int roomId;
    public int awayFlag;
    public int openToMsgs;
    private static int instances = 0;

    public void setColorNbr(int colorNbr) {
        this.colorNbr = colorNbr;
    }

    public User(String name, int id, int x, int y, int roomId, int faceNbr, int colorNbr, 
            int awayFlag, int openToMsgs, int numberProps, int propIDs[], int propCRCs[]) {
        this.x = 0;
        this.y = 0;
        this.faceNbr = 0;
        this.colorNbr = 0;
        this.numberProps = 0;
        this.name = null;
        this.id = 0;
        this.propIDs = null;
        this.propCRCs = null;
        propUnfulfilled = null;
        pprops = null;
        hideFaceFlag = false;
        this.roomId = 0;
        this.awayFlag = 0;
        this.openToMsgs = 0;
        this.name = name;
        this.id = id;
        this.x = x;
        this.y = y;
        this.faceNbr = faceNbr;
        this.colorNbr = colorNbr;
        this.numberProps = numberProps;
        this.propIDs = propIDs;
        this.propCRCs = propCRCs;
        this.roomId = roomId;
        this.awayFlag = awayFlag;
        this.openToMsgs = openToMsgs;
        pprops = new PalaceProp[9];
        propUnfulfilled = new boolean[9];
    }

    public int id() {
        return id;
    }

    public void speech(String s, boolean flag, int i, SerialSpeech serialspeech) {
    }

    public synchronized void setXY(int x, int y) {
        this.x = x;
        this.y = y;
    }

    public void done() {
        ClearPropRefs();
        propIDs = null;
        propCRCs = null;
        pprops = null;
        propUnfulfilled = null;
    }

    public synchronized void ClearPropRefs() {
        for(int i = 0; i < 9; i++)
            pprops[i] = null;

    }

    boolean CheckForNewProps() {
        return false;
    }

    public void setName(String name) {
        this.name = name;
    }

    public void setFaceNbr(int faceNbr) {
        this.faceNbr = faceNbr;
    }

    public int getFaceNbr() {
        return faceNbr;
    }

    public synchronized void setProps(int numberProps, int propIDs[], int propCRCs[]) {
        this.numberProps = numberProps;
        this.propIDs = propIDs;
        this.propCRCs = propCRCs;
    }

    public boolean ResolveProps(PropTable pt) {
        for(int i = 0; i < numberProps; i++) {
            PalaceProp prop = pt.PropReference(propIDs[i], propCRCs[i]);
            synchronized(this) {
                pprops[i] = prop;
                if(prop != null)
                    propUnfulfilled[i] = prop.unfulfilled;
                else
                    propUnfulfilled[i] = false;
            }
        }

        return CheckForNewProps();
    }

}
