// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 15:04:52 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.pob;

import communities.utl.NetDataInputStream;
import communities.utl.NetDataOutputStream;
import java.io.IOException;

public class UserRec {

    public int userId;
    public int x;
    public int y;
    public int roomId;
    public int faceNumber;
    public int colorNumber;
    public int awayFlag;
    public int openToMsgs;
    public int numberProps;
    public int propIDs[];
    public int propCRCs[];
    public String name;

    public String toString() {
        String s = new String();
        s = name;
        return s;
    }

    public UserRec(int iuserId, int ix, int iy, int iroomId, int ifaceNumber, int icolorNumber, int iawayFlag, 
            int iopenToMsgs, int inumberProps, int ipropIDs[], int ipropCRCs[], String sname) {
        userId = 0;
        x = 0;
        y = 0;
        roomId = 0;
        faceNumber = 0;
        colorNumber = 0;
        awayFlag = 0;
        openToMsgs = 0;
        numberProps = 0;
        propIDs = null;
        propCRCs = null;
        name = null;
        userId = iuserId;
        x = ix;
        y = iy;
        roomId = iroomId;
        faceNumber = ifaceNumber;
        colorNumber = icolorNumber;
        awayFlag = iawayFlag;
        openToMsgs = iopenToMsgs;
        numberProps = inumberProps;
        propIDs = new int[ipropIDs.length];
        propCRCs = new int[ipropCRCs.length];
        for(int i = 0; i < ipropIDs.length; i++) {
            propIDs[i] = ipropIDs[i];
            propCRCs[i] = ipropCRCs[i];
        }

        name = new String(sname);
    }

    public UserRec(NetDataInputStream ndis) throws IOException {
        userId = 0;
        x = 0;
        y = 0;
        roomId = 0;
        faceNumber = 0;
        colorNumber = 0;
        awayFlag = 0;
        openToMsgs = 0;
        numberProps = 0;
        propIDs = null;
        propCRCs = null;
        name = null;
        userId = ndis.readInt();
        y = ndis.readShort();
        x = ndis.readShort();
        propIDs = new int[9];
        propCRCs = new int[9];
        for(int i = 0; i < 9; i++) {
            propIDs[i] = ndis.readInt();
            propCRCs[i] = ndis.readInt();
        }

        roomId = ndis.readShort();
        faceNumber = ndis.readShort();
        colorNumber = ndis.readShort();
        awayFlag = ndis.readShort();
        openToMsgs = ndis.readShort();
        numberProps = ndis.readShort();
        byte bs[] = new byte[32];
        ndis.readFully(bs);
        name = new String(bs, 0, 1, bs[0]);
    }

    public static int size() {
        return 124;
    }

    public void write(NetDataOutputStream ndos) throws IOException {
        ndos.writeInt(userId);
        ndos.writeShort(y);
        ndos.writeShort(x);
        for(int i = 0; i < 9; i++) {
            ndos.writeInt(propIDs[i]);
            ndos.writeInt(propCRCs[i]);
        }

        ndos.writeShort(roomId);
        ndos.writeShort(faceNumber);
        ndos.writeShort(colorNumber);
        ndos.writeShort(awayFlag);
        ndos.writeShort(openToMsgs);
        ndos.writeShort(numberProps);
        byte bs[] = new byte[32];
        int len = name.length();
        if(len > 31)
            len = 31;
        bs[0] = (byte)len;
        name.getBytes(0, len, bs, 1);
        ndos.write(bs, 0, 32);
    }
}
