// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 15:11:51 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.sec;

import java.io.PrintStream;
import java.net.URL;
import java.security.AccessController;

// Referenced classes of package communities.sec:
//            PalaceSecurityManager, PerformAction, IPalaceSecurity

final class JavaSecurity
    implements IPalaceSecurity {

    static void initialize(PalaceSecurityManager mgr) {
        try {
            if(Class.forName("java.security.AccessController") != null) {
                mgr.setSecurity(new JavaSecurity());
                System.err.println("Using Java security.");
            }
        }
        catch(ClassNotFoundException e) { }
        catch(SecurityException e) { }
    }

    public void connectTo(URL aURL, Runnable theCode) throws SecurityException {
        checkValidity();
        AccessController.doPrivileged(new PerformAction(theCode));
    }

    private JavaSecurity() {
    }

    private static void checkValidity() throws SecurityException {
    }
}
