// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 15:11:51 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.sec;

import java.io.PrintStream;
import java.net.URL;
import netscape.security.PrivilegeManager;

// Referenced classes of package communities.sec:
//            PalaceSecurityManager, IPalaceSecurity

final class NetscapeSecurity
    implements IPalaceSecurity {

    static void initialize(PalaceSecurityManager mgr) {
        try {
            if(Class.forName("netscape.security.PrivilegeManager") != null) {
                mgr.setSecurity(new NetscapeSecurity());
                System.err.println("Using Netscape security.");
            }
        }
        catch(ClassNotFoundException e) { }
        catch(SecurityException e) { }
    }

    public void connectTo(URL aURL, Runnable theCode) throws SecurityException {
        checkValidity();
        try {
            PrivilegeManager.enablePrivilege("UniversalConnect");
        }
        finally {
            theCode.run();
        }
    }

    private NetscapeSecurity() {
    }

    private static void checkValidity() throws SecurityException {
    }
}
