// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 15:15:06 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.utl;

import java.awt.*;

// Referenced classes of package communities.utl:
//            ImagePane

public class HighlightButton extends ImagePane {

    boolean isSticky;
    boolean isStuck;
    private boolean mMouseDown;
    private boolean mInside;

    protected Point getUpperLeft() {
        return new Point(3, 3);
    }

    public boolean mouseEnter(Event evt, int x, int y) {
        setInside(true);
        return true;
    }

    protected void clickSelf() {
    }

    private boolean isMouseDown() {
        return mMouseDown;
    }

    public void unStick() {
        if(isSticky) {
            isStuck = false;
            repaint();
        }
    }

    public boolean mouseExit(Event evt, int x, int y) {
        setInside(false);
        return true;
    }

    public void stick() {
        if(isSticky)
            isStuck = true;
    }

    public boolean isStuck() {
        return isStuck;
    }

    public HighlightButton(Image image, int width, int height, boolean isSticky) {
        super(image, width, height);
        this.isSticky = false;
        isStuck = false;
        mMouseDown = false;
        mInside = false;
        this.isSticky = isSticky;
    }

    public synchronized void paint(Graphics g) {
        super.paint(g);
        drawHighlight(g);
    }

    public boolean mouseUp(Event evt, int x, int y) {
        setMouseDown(false);
        if(inside(x, y)) {
            clickSelf();
            if(isSticky)
                isStuck = true;
        }
        return true;
    }

    public Dimension minimumSize() {
        Dimension superSize = super.minimumSize();
        int width = superSize.width + 6;
        int height = superSize.height + 6;
        return new Dimension(width, height);
    }

    private synchronized void setInside(boolean inside) {
        mInside = inside;
        repaint();
    }

    public boolean mouseDown(Event evt, int x, int y) {
        setMouseDown(true);
        return true;
    }

    private void drawHighlight(Graphics g) {
        if(g != null && (isInside() || isStuck)) {
            Color save = g.getColor();
            boolean raised = !isMouseDown();
            if(isStuck)
                raised = false;
            g.setColor(Color.lightGray);
            g.draw3DRect(0, 0, size().width - 1, size().height - 1, raised);
            g.setColor(save);
        }
    }

    private boolean isInside() {
        return mInside;
    }

    private void setMouseDown(boolean down) {
        mMouseDown = down;
        repaint();
    }
}
