// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 15:15:06 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.utl;

import java.awt.*;

// Referenced classes of package communities.utl:
//            IInputBoxParent

public class InputBox extends Dialog
    implements IInputBoxParent {

    IInputBoxParent mParent;
    TextField mTextInput;
    Button mOKButton;

    public InputBox(IInputBoxParent parent, Frame parentFrame, String strTitle, String strPrompt) {
        super(parentFrame, strTitle, true);
        mParent = null;
        mTextInput = null;
        mOKButton = null;
        mParent = parent;
        setLayout(null);
        resize(340, 170);
        setFont(new Font("Dialog", 0, 12));
        FontMetrics fm = getFontMetrics(getFont());
        int promptWidth = fm.stringWidth(strPrompt) + 16;
        int promptHeight = fm.getHeight() + 4;
        Label prompt = new Label(strPrompt);
        prompt.reshape(10, 40, promptWidth, promptHeight);
        add(prompt);
        mTextInput = new TextField();
        mTextInput.reshape(18, 40 + promptHeight + 20, 258, 24);
        add(mTextInput);
        mOKButton = new Button("OK");
        mOKButton.reshape(280, 40 + promptHeight + 20, 40, 24);
        add(mOKButton);
        setBackground(Color.lightGray);
    }

    public void inputBoxDismissed(InputBox inputbox) {
    }

    public void paint(Graphics g) {
        g.setColor(Color.white);
        g.draw3DRect(6, 10, size().width - 18, 100, false);
    }

    public void show() {
        Dimension screenD = Toolkit.getDefaultToolkit().getScreenSize();
        Frame TopFrame = null;
        for(Component c = this; c != null; c = c.getParent())
            if(c instanceof Frame)
                TopFrame = (Frame)c;

        Point FrameLoc;
        if(TopFrame != null)
            FrameLoc = TopFrame.location();
        else
            FrameLoc = new Point(100, 100);
        Dimension mySize = size();
        int x = (screenD.width - mySize.width) / 2;
        int y = (screenD.height - mySize.height) / 2;
        reshape(x, y, mySize.width, mySize.height);
        if(mTextInput != null)
            mTextInput.requestFocus();
        super.show();
    }

    public boolean action(Event event, Object what) {
        if(event.target == mOKButton || event.target == mTextInput) {
            mParent.inputBoxDismissed(this);
            return true;
        } else {
            return false;
        }
    }

    public Insets insets() {
        return new Insets(10, 10, 10, 10);
    }

    public boolean handleEvent(Event evt) {
        if(evt.id == 201)
            dispose();
        return super.handleEvent(evt);
    }

    public String getInputValue() {
        if(mTextInput != null)
            return mTextInput.getText();
        else
            return null;
    }
}
