// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 15:15:06 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.utl;

import communities.IPalaceCore;
import java.applet.AudioClip;
import java.io.PrintStream;
import java.util.Vector;

// Referenced classes of package communities.utl:
//            PalaceSound, ResourceInfo

public class PalaceSoundManager {

    private Vector mSounds;
    private IPalaceCore mApplet;

    public synchronized void stopSounds() {
        if(isInitialized()) {
            for(int i = 0; i < mSounds.size(); i++) {
                PalaceSound sound = getSoundAt(i);
                if(sound != null) {
                    sound.getAudioClip().stop();
                    if(sound.isAlive()) {
                        sound.stop();
                        if(mApplet.getResourceInfo().getDebug() > 0)
                            System.out.println(sound + " download stopped");
                    } else
                    if(mApplet.getResourceInfo().getDebug() > 0)
                        System.out.println("Sound was dead");
                }
            }

            clear();
        }
    }

    private synchronized boolean isInitialized() {
        return mSounds != null;
    }

    public PalaceSoundManager(IPalaceCore applet) {
        mSounds = null;
        mApplet = null;
        mApplet = applet;
        init();
    }

    public synchronized void addSound(PalaceSound sound) {
        if(!isInitialized())
            init();
        mSounds.addElement(sound);
    }

    private synchronized PalaceSound getSoundAt(int i) {
        if(!isInitialized())
            return null;
        else
            return (PalaceSound)mSounds.elementAt(i);
    }

    private synchronized void clear() {
        mSounds = null;
    }

    private synchronized void init() {
        mSounds = new Vector();
    }
}
