// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 15:15:06 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.utl;


public class TextCrypto {

    private static int keyText[];
    private static int gSeed;

    private static int random() {
        int hi = gSeed / 0x1f31d;
        int lo = gSeed % 0x1f31d;
        int test = 16807 * lo - 2836 * hi;
        if(test > 0)
            gSeed = test;
        else
            gSeed = test + 0x7fffffff;
        return gSeed;
    }

    private static int myRandom(int max) {
        return (short)(int)(doubleRandom() * (double)max);
    }

    public TextCrypto() {
    }

    private static void mySRand(int s) {
        gSeed = s;
        if(gSeed == 0)
            gSeed = 1;
    }

    public static String encryptString(String inStr) {
        byte lastChar = 0;
        byte bs[] = new byte[inStr.length()];
        int rc = 0;
        for(int i = inStr.length() - 1; i >= 0; i--) {
            byte b = (byte)inStr.charAt(i);
            bs[i] = (byte)(b ^ keyText[rc++] ^ lastChar);
            lastChar = (byte)(bs[i] ^ keyText[rc++]);
        }

        return new String(bs, 0);
    }

    private static double doubleRandom() {
        return (double)random() / 2147483647D;
    }

    public static String decryptString(String inStr) {
        byte lastChar = 0;
        byte bs[] = new byte[inStr.length()];
        int rc = 0;
        for(int i = inStr.length() - 1; i >= 0; i--) {
            byte tmp = (byte)inStr.charAt(i);
            bs[i] = (byte)(tmp ^ keyText[rc++] ^ lastChar);
            lastChar = (byte)(tmp ^ keyText[rc++]);
        }

        return new String(bs, 0);
    }

    static  {
        mySRand(0xa2c2a);
        keyText = new int[512];
        for(int i = 0; i < 512; i++)
            keyText[i] = myRandom(256);

        mySRand(0);
    }
}
