// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 14:52:31 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.adm;

import communities.IPalaceCore;
import communities.pkt.PPEventSuperUser;
import communities.plg.IMessageBoxParent;
import communities.plg.MessageBox;
import communities.pob.Room;
import communities.utl.*;
import java.applet.Applet;
import java.applet.AudioClip;
import java.awt.*;

// Referenced classes of package communities.adm:
//            URLPanel, AdminPanel, IAdministrator

public class Admin
    implements IAdministrator, IMessageBoxParent, IInputBoxParent {

    private IPalaceCore itsCore;
    private ResourceInfo resInfo;
    private boolean isAdmin;
    private boolean isOperator;

    public Component addURLPanel() {
        return new URLPanel();
    }

    public Admin(IPalaceCore core) {
        isAdmin = false;
        isOperator = false;
        itsCore = core;
        resInfo = itsCore.getResourceInfo();
    }

    public void inputBoxDismissed(InputBox dlg) {
        dlg.hide();
        String password = dlg.getInputValue();
        if(password != null) {
            PPEventSuperUser su = new PPEventSuperUser(password, ((Room) (itsCore.getRoom())).userID);
            itsCore.sendPPEvent(su);
        }
        dlg = null;
    }

    private String wrapText(String msg) {
        int lineLen = 0;
        int i = 0;
        int maxLineLen = 300;
        FontMetrics fm = ((Applet)itsCore).getFontMetrics(new Font("Dialog", 0, 12));
        int msgLen = msg.length();
        char msgChars[] = new char[msgLen];
        msg.getChars(0, msgLen, msgChars, 0);
        for(; i < msgLen; i++) {
            if(msgChars[i] == '\n')
                lineLen = 0;
            else
                lineLen += fm.charWidth(msgChars[i]);
            if(lineLen >= maxLineLen) {
                int bookmark = i;
                while(msgChars[i] != ' ')  {
                    if(--i <= 0) {
                        i = bookmark;
                        break;
                    }
                    if(msgChars[i] == ' ') {
                        msgChars[i] = '\n';
                        lineLen = 0;
                        break;
                    }
                }
            }
        }

        return new String(msgChars + "\n");
    }

    public void handlePage(String msg) {
        if(resInfo.dingOnPage) {
            AudioClip yes = resInfo.getSound("yes");
            if(yes != null)
                yes.play();
        }
        if(resInfo.messageBoxOnPage) {
            String wrappedMsg = wrapText(msg);
            MessageBox mbPage = new MessageBox(this, itsCore.getAppletFrame(), "You have been paged", wrappedMsg, 1, null);
            mbPage.show();
        }
    }

    public void messageBoxDismissed(MessageBox mbDlg) {
        mbDlg.hide();
        mbDlg = null;
    }

    public void handleAdminButtonClick() {
        if(!isOperator) {
            InputBox passwordBox = new InputBox(this, itsCore.getAppletFrame(), "Operator/Administrator Password", "Enter the Operator or Administrator password:");
            passwordBox.show();
        }
    }

    public Component addAdminPanel() {
        return new AdminPanel();
    }
}
