// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 15:16:59 

// Source File Name:   [DashoPro-V1.2-120198]

package communities;

import communities.pkt.PPEvent;
import communities.pkt.PPEventExtendedInfo;
import communities.plg.PalPresentsEventGrabber;
import communities.plg.PluginMgr;
import communities.pob.PalaceEventsThread;
import communities.pob.Room;
import communities.utl.Connection;
import communities.utl.ResourceInfo;
import java.io.IOException;
import java.io.PrintStream;

// Referenced classes of package communities:
//            instantpal, Palace2DCanvas, PalaceErrorHandler, PalaceRTException

class instantpal$IntroProcessor
    implements Runnable {

    final instantpal this$0; /* synthetic field */

    public instantpal$IntroProcessor(instantpal this$0) {
        (this.this$0 = this$0).getClass();
    }

    public synchronized void run() {
        try {
            if(this$0.mResourceInfo.getDebug() > 0)
                System.err.println("IntroProcessor.run");
            if(this$0.mResourceInfo.isPalacePresentsEnabled() && this$0.mPluginMgr == null) {
                this$0.mPluginMgr = new PluginMgr(this$0, this$0.palaceCommander);
                PalPresentsEventGrabber aGrabber = new PalPresentsEventGrabber(this$0.mPluginMgr, this$0.theSecurityManager);
                this$0.mPalacePresents = aGrabber;
                this$0.mPluginMgr.add(0x10041, aGrabber);
            }
            this$0.setNavInProgress(true);
            this$0.showStatus("Connecting...");
            if(!this$0.didConnectToPalace())
                return;
            if(this$0.canvas != null)
                this$0.canvas.resetGraphicError();
            try {
                PPEvent p;
                for(p = this$0.readPPEvent(); p.type() == 0x72657370 || p.type() == 0x70736572; p = this$0.readPPEvent()) {
                    System.err.println("Got a MSG_RESPORT");
                    int resport = p.refNum();
                    this$0.mConnection.setRespPort(resport);
                }

                if(p.type() == 0x74697972) {
                    System.err.println("got a TIYID");
                    this$0.room.setUserID(p.refNum());
                    PPEventExtendedInfo ei = new PPEventExtendedInfo(((Room) (this$0.room)).userID);
                    this$0.sendPPEvent(ei);
                } else {
                    System.err.println("Expected packet MSG_TIYID");
                }
            }
            catch(IOException e) {
                this$0.reportError("Logon to the server failed");
                return;
            }
            catch(ThreadDeath e) {
                this$0.mErrorHandler.reportError("instantpal run: THREAD DEATH", 2);
                throw e;
            }
            catch(NullPointerException npe) {
                this$0.mErrorHandler.reportError("readPPEvent: NULL event", 2);
                return;
            }
            Runnable eventThread = new PalaceEventsThread(this$0);
            eventThread.run();
            this$0.bInitialized = true;
        }
        catch(PalaceRTException e) {
            this$0.doFinally = false;
            this$0.mErrorHandler.reportError(e.toString(), 3);
        }
        finally {
            if(this$0.doFinally)
                this$0.palaceEventsDone();
            else
                this$0.doFinally = true;
        }
    }
}
