// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 14:52:51 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.pkt;

import communities.utl.NetDataInputStream;
import java.io.IOException;

// Referenced classes of package communities.pkt:
//            PPEvent

public class PPEventAssetSend extends PPEvent {

    public int assetType;
    public int assetID;
    public int assetCRC;
    public int blockSize;
    public int blockOffset;
    public short blockNbr;
    public short nbrBlocks;
    public int flags;
    public int assetSize;
    public String assetName;
    public byte data[];

    public PPEventAssetSend() {
        assetType = 0;
        assetID = 0;
        assetCRC = 0;
        blockSize = 0;
        blockOffset = 0;
        blockNbr = 0;
        nbrBlocks = 0;
        flags = 0;
        assetSize = 0;
        assetName = null;
        data = null;
    }

    public void read(NetDataInputStream ndis) throws IOException {
        assetType = ndis.readInt();
        assetID = ndis.readInt();
        assetCRC = ndis.readInt();
        blockSize = ndis.readInt();
        blockOffset = ndis.readInt();
        blockNbr = ndis.readShort();
        nbrBlocks = ndis.readShort();
        if(blockNbr == 0) {
            flags = ndis.readInt();
            assetSize = ndis.readInt();
            byte bs[] = new byte[32];
            ndis.readFully(bs);
            assetName = new String(bs, 0, 1, bs[0]);
        }
        data = new byte[blockSize];
        ndis.readFully(data);
        int padding = super.size - (blockSize + 64);
        for(int i = 0; i < padding; i++)
            ndis.readByte();

    }
}
