// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 14:52:51 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.pkt;

import communities.utl.NetDataInputStream;
import communities.utl.NetDataOutputStream;
import java.io.IOException;

// Referenced classes of package communities.pkt:
//            PPEvent

public class PPEventDoorLock extends PPEvent {

    public int roomID;
    public int spotID;

    public PPEventDoorLock() {
        roomID = 0;
        spotID = 0;
    }

    public void read(NetDataInputStream ndis) throws IOException {
        roomID = ndis.readShort();
        spotID = ndis.readShort();
    }

    public PPEventDoorLock(int userId, int roomID, int spotID, boolean locked) {
        this.roomID = 0;
        this.spotID = 0;
        if(locked)
            super.event = 0x6c6f636b;
        else
            super.event = 0x756e6c6f;
        super.size = 4;
        super.refNum = userId;
        this.roomID = roomID;
        this.spotID = spotID;
    }

    public void write(NetDataOutputStream ndos) throws IOException {
        super.writeNoFlush(ndos);
        ndos.writeShort(roomID);
        ndos.writeShort(spotID);
        super.flush(ndos);
    }
}
