// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 14:52:51 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.pkt;

import communities.PalaceMsgStrings;
import communities.utl.NetDataOutputStream;
import java.io.IOException;

// Referenced classes of package communities.pkt:
//            PPEvent

public class PPEventLogon extends PPEvent
    implements PalaceMsgStrings {

    String userName;
    int regInts[] = {
        0x5905f923, 0xcf07309c
    };
    int auxFlags;
    int puidCtr;
    int puidCRC;
    int demoElapsed;
    int totalElapsed;
    int demoLimit;
    short desiredRoom;

    public PPEventLogon(int userId, String userName, int roomID) {
        this.userName = null;
        auxFlags = 5;
        puidCtr = 0;
        puidCRC = 0;
        demoElapsed = 0;
        totalElapsed = 0;
        demoLimit = 0;
        desiredRoom = 0;
        super.event = 0x72656769;
        super.refNum = userId;
        this.userName = userName;
        desiredRoom = (short)(roomID <= 0 ? 0 : roomID);
    }

    public void write(NetDataOutputStream ndos) throws IOException {
        super.size = 128;
        super.writeNoFlush(ndos);
        ndos.writeInt(regInts[0]);
        ndos.writeInt(regInts[1]);
        ndos.writeByte(userName.length());
        ndos.writeBytes(userName);
        int n = 64 - (1 + userName.length());
        if(n < 0)
            n = 0;
        for(; n > 0; n--)
            ndos.writeByte(0);

        ndos.writeInt(auxFlags);
        ndos.writeInt(puidCtr);
        ndos.writeInt(puidCRC);
        ndos.writeInt(demoElapsed);
        ndos.writeInt(totalElapsed);
        ndos.writeInt(demoLimit);
        ndos.writeShort(desiredRoom);
        String version = "J" + "2" + "." + "3" + "." + "0";
        if(version.length() > 6)
            try {
                version = version.substring(0, 6);
            }
            catch(StringIndexOutOfBoundsException exc) {
                version = "J2.3.0";
            }
        ndos.writeBytes(version);
        ndos.writeInt(0);
        ndos.writeInt(0);
        ndos.writeInt(0);
        ndos.writeInt(0);
        ndos.writeInt(0);
        ndos.writeInt(0);
        super.flush(ndos);
    }
}
