// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 14:53:14 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.plg;

import communities.IPalaceCore;
import communities.IPalaceUI;
import java.awt.*;

public class EventListPanel extends Panel {

    private Button m_InfoButton;
    private Button m_JoinButton;
    public List m_EventList;
    private IPalaceCore mCore;
    private IPalaceUI mUI;
    int numEvents;

    public EventListPanel(IPalaceUI itsUI) {
        m_InfoButton = null;
        m_JoinButton = null;
        m_EventList = null;
        mCore = null;
        mUI = null;
        numEvents = 0;
        mUI = itsUI;
        mCore = itsUI.getCore();
        setLayout(new BorderLayout());
        Label eventListLabel = new Label("Events in progress:");
        eventListLabel.setFont(new Font("Courier", 1, 12));
        add("North", eventListLabel);
        m_EventList = new List(0, false);
        m_EventList.addItem("<none>");
        add("Center", m_EventList);
        m_EventList.setBackground(new Color(0xffffff));
        m_EventList.setFont(new Font("Courier", 0, 12));
        m_EventList.setMultipleSelections(false);
        m_JoinButton = new Button("Join");
        m_InfoButton = new Button("Info URL");
        m_JoinButton.disable();
        m_InfoButton.disable();
        Panel p = new Panel();
        p.setLayout(new FlowLayout(1));
        p.add(m_JoinButton);
        p.add(m_InfoButton);
        add("South", p);
    }

    public void paint(Graphics g) {
        Color save = g.getColor();
        Dimension size = size();
        g.setColor(Color.white);
        g.drawRect(1, 1, size.width - 2, size.height - 2);
        g.setColor(Color.gray);
        g.drawRect(0, 0, size.width - 2, size.height - 2);
        g.setColor(save);
    }

    public void select(int index) {
        m_EventList.select(index);
        m_JoinButton.enable();
        m_InfoButton.enable();
    }

    public boolean action(Event e, Object arg) {
        boolean handled = false;
        if(e.target == m_JoinButton) {
            mCore.handleEventJoin();
            handled = true;
        } else
        if(e.target == m_InfoButton) {
            mCore.handleEventInfo();
            handled = true;
        } else {
            handled = super.action(e, arg);
        }
        return handled;
    }

    public Insets insets() {
        return new Insets(3, 3, 3, 3);
    }

    public boolean keyDown(Event e, int key) {
        boolean handled;
        if(e.target == m_EventList && (key == 10 || key == 13))
            handled = true;
        else
            handled = super.keyDown(e, key);
        return handled;
    }
}
