// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 14:53:14 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.plg;

import communities.utl.NetDataInputStream;
import communities.utl.NetDataOutputStream;
import java.io.IOException;

// Referenced classes of package communities.plg:
//            PPPEvent

public class PPPEventGotoURL extends PPPEvent {

    protected byte m_popup;
    String m_URL;

    public PPPEventGotoURL(PPPEvent ppEvent) {
        super(ppEvent);
        m_popup = 0;
        m_URL = null;
    }

    public void read(NetDataInputStream ndis) throws IOException {
        byte bs[] = new byte[super.m_AudDataLen];
        ndis.readFully(bs);
        int urlTermIdx = -1;
        int popupFlagIdx = -1;
        for(int cnt = 0; cnt < bs.length; cnt++)
            if(bs[cnt] == 0 && urlTermIdx == -1) {
                urlTermIdx = cnt;
                popupFlagIdx = cnt + 1;
            }

        if(urlTermIdx != -1)
            m_URL = new String(bs, 0, 0, urlTermIdx);
        if(popupFlagIdx < bs.length)
            m_popup = bs[popupFlagIdx];
        else
            m_popup = 0;
        bs = null;
    }

    public void write(NetDataOutputStream ndos) throws IOException {
        super.write(ndos);
    }

    public String getURL() {
        return m_URL;
    }

    public byte getPopup() {
        return m_popup;
    }
}
