// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 14:53:14 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.plg;

import communities.*;
import communities.pob.User;
import communities.sec.IPalaceSecurity;
import communities.sec.Privileged;
import communities.utl.ResourceInfo;
import java.applet.Applet;
import java.awt.*;

// Referenced classes of package communities.plg:
//            PalPresentNewTabPanel, PPTabPanelButtonBar, IPalPresentsUI

public final class PalPresentsUI
    implements IPalPresentsUI, Privileged {

    IPalaceUI itsUI;
    IPalaceCore mApplet;
    public PalPresentNewTabPanel m_StageTabPanel;
    private transient IPalaceSecurity mSecurity;

    public void updateUserList() {
        PalaceUserList userList = m_StageTabPanel.getUserList();
        userList.clear();
        for(int i = 0; i < mApplet.getUserListCount(); i++)
            userList.addUser(mApplet.buildUserString(i));

        userList.select(0);
    }

    public void setSecurity(IPalaceSecurity m) {
        mSecurity = m;
    }

    public void hideUI() {
        ResourceInfo resInfo = mApplet.getResourceInfo();
        if(resInfo.PPTabPanelEnabled)
            if(resInfo.tabPanelFloats)
                mApplet.getUI().getTabPanelFrame().remove(m_StageTabPanel);
            else
                ((Applet)mApplet).remove(m_StageTabPanel);
        if(resInfo.buttonPanelEnabled)
            ((Applet)mApplet).remove(m_StageTabPanel.getButtonBar());
    }

    public PalPresentsUI(IPalaceCore itsApplet) {
        m_StageTabPanel = null;
        mApplet = itsApplet;
        itsUI = mApplet.getUI();
    }

    public void initUI() {
        ResourceInfo resInfo = mApplet.getResourceInfo();
        if(resInfo.PPTabPanelEnabled) {
            m_StageTabPanel = new PalPresentNewTabPanel(mApplet.getUI(), mApplet, mSecurity, resInfo, mApplet.getUI().getTabPanelFrame());
            if(!resInfo.tabPanelFloats)
                m_StageTabPanel.reshape(resInfo.tabPanelRect.x, resInfo.tabPanelRect.y, resInfo.tabPanelRect.width, resInfo.tabPanelRect.height);
            else
                m_StageTabPanel.reshape(4, 22, resInfo.tabPanelRect.width, resInfo.tabPanelRect.height);
            if(resInfo.buttonPanelEnabled) {
                PPTabPanelButtonBar bar = m_StageTabPanel.getButtonBar();
                bar.reshape(resInfo.buttonPanelRect.x, resInfo.buttonPanelRect.y, resInfo.buttonPanelRect.width, resInfo.buttonPanelRect.height);
                bar.setBackground(resInfo.bkgColor);
            }
        }
    }

    public void logText(User u, String msg, boolean privateFlag) {
        ResourceInfo resInfo = mApplet.getResourceInfo();
        if(resInfo.PPTranscriptPanelEnabled)
            m_StageTabPanel.getLog().logText(u, msg, privateFlag);
    }

    public void showUI() {
        ResourceInfo resInfo = mApplet.getResourceInfo();
        if(resInfo.PPTabPanelEnabled) {
            if(resInfo.tabPanelFloats)
                mApplet.getUI().getTabPanelFrame().add(m_StageTabPanel);
            else
                ((Applet)mApplet).add(m_StageTabPanel);
            Container cont = m_StageTabPanel.getMContainer();
            CardLayout cl = (CardLayout)cont.getLayout();
            cl.first(cont);
        }
        if(resInfo.buttonPanelEnabled) {
            ((Applet)mApplet).add(m_StageTabPanel.getButtonBar());
            if(!resInfo.tabPanelFloats)
                m_StageTabPanel.mButtonBar.depress(3);
        }
    }
}
