// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 14:53:14 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.plg;

import communities.IPalaceCore;
import communities.pkt.PPEvent;
import communities.pob.PalaceCommander;
import communities.utl.NetDataInputStream;
import java.io.IOException;
import java.util.*;

// Referenced classes of package communities.plg:
//            IPlugin, PPEventBlowThru, IPalPresentsEventTypes

public class PluginMgr
    implements IPalPresentsEventTypes {

    Hashtable m_PluginTable;
    public IPalaceCore m_theApplet;
    public PalaceCommander m_palCmdr;

    public IPlugin get(int PluginID) {
        Integer i = new Integer(PluginID);
        IPlugin PluginHandler = (IPlugin)m_PluginTable.get(i);
        i = null;
        return PluginHandler;
    }

    public void notifyPPEvent(PPEvent ppEvent) {
        for(Enumeration e = m_PluginTable.elements(); e.hasMoreElements();)
            try {
                IPlugin PluginHandler = (IPlugin)e.nextElement();
                PluginHandler.processPPEvent(ppEvent);
            }
            catch(NoSuchElementException ne) { }

    }

    public void sendBlowThruEvent(PPEventBlowThru PPEvtBlowThru) {
        m_theApplet.sendPPEvent(PPEvtBlowThru);
    }

    public PluginMgr(IPalaceCore theApplet, PalaceCommander palCmdr) {
        m_theApplet = null;
        m_palCmdr = null;
        m_theApplet = theApplet;
        m_palCmdr = palCmdr;
        m_PluginTable = new Hashtable(5);
    }

    public boolean add(int PluginID, IPlugin PluginHandler) {
        Integer i = new Integer(PluginID);
        if(m_PluginTable.get(i) != null) {
            i = null;
            return false;
        }
        try {
            m_PluginTable.put(i, PluginHandler);
        }
        catch(NullPointerException e) {
            i = null;
            return false;
        }
        return true;
    }

    public void CheckUserProps() {
        for(Enumeration e = m_PluginTable.elements(); e.hasMoreElements();)
            try {
                IPlugin PluginHandler = (IPlugin)e.nextElement();
                PluginHandler.checkUserProps();
            }
            catch(NoSuchElementException ne) { }

    }

    public PPEvent getIncomingData(PPEventBlowThru ppEvtBlowThru, NetDataInputStream ndis) throws IOException {
        IPlugin PluginHandler = get(ppEvtBlowThru.getBlowThruID());
        if(PluginHandler != null)
            return PluginHandler.getIncomingData(ppEvtBlowThru, ndis);
        else
            return null;
    }

    public boolean dispatchBlowThruEvent(PPEventBlowThru PPEvtBlowThru) {
        IPlugin PluginHandler = get(PPEvtBlowThru.getBlowThruID());
        if(PluginHandler != null)
            return PluginHandler.processBlowThruEvent(PPEvtBlowThru);
        else
            return false;
    }

    public IPalaceCore getPalaceApplet() {
        return m_theApplet;
    }
}
