// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 14:53:14 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.plg;

import communities.utl.NetDataInputStream;
import java.io.IOException;

// Referenced classes of package communities.plg:
//            LayoutStruct

public class StageDesc {

    public int m_Version;
    public int m_flags;
    public String m_StageName;
    public String m_InfoURL;
    public String m_BackgroundName;
    public String m_MediaURL;
    public int m_MediaWidth;
    public int m_MediaHeight;
    public LayoutStruct m_LayoutInfo;

    public String toString() {
        String s = new String();
        s = "\r Version : " + m_Version + "\r" + "\r Flags   : " + m_flags + "\r" + "\r Stage name : " + m_StageName + "\r" + "\r Info URL   : " + m_InfoURL + "\r" + "\r Background file : " + m_BackgroundName + "\r" + "\r Media URL : " + m_MediaURL + "\r" + "\r Media Width : " + m_MediaWidth + "\r" + "\r Media Height : " + m_MediaHeight + "\r" + "\r**END**\r";
        return s;
    }

    public StageDesc() {
        m_Version = 0;
        m_flags = 0;
        m_StageName = null;
        m_InfoURL = null;
        m_BackgroundName = null;
        m_MediaURL = null;
        m_MediaWidth = 0;
        m_MediaHeight = 0;
        m_LayoutInfo = null;
        m_LayoutInfo = new LayoutStruct();
    }

    public void read(NetDataInputStream ndis) throws IOException {
        m_Version = ndis.readInt();
        m_flags = ndis.readInt();
        byte bs[] = new byte[128];
        ndis.readFully(bs);
        m_StageName = new String(bs, 0, 0, 128);
        if(m_StageName.indexOf('\0') != -1)
            m_StageName = m_StageName.substring(0, m_StageName.indexOf('\0'));
        bs = null;
        bs = new byte[128];
        ndis.readFully(bs);
        m_InfoURL = new String(bs, 0, 0, 128);
        if(m_InfoURL.indexOf('\0') != -1)
            m_InfoURL = m_InfoURL.substring(0, m_InfoURL.indexOf('\0'));
        bs = null;
        bs = new byte[255];
        ndis.readFully(bs);
        m_BackgroundName = new String(bs, 0, 0, 255);
        if(m_BackgroundName.indexOf('\0') != -1)
            m_BackgroundName = m_BackgroundName.substring(0, m_BackgroundName.indexOf('\0'));
        bs = null;
        bs = new byte[128];
        ndis.readFully(bs);
        m_MediaURL = new String(bs, 0, 0, 128);
        if(m_MediaURL.indexOf('\0') != -1)
            m_MediaURL = m_MediaURL.substring(0, m_MediaURL.indexOf('\0'));
        bs = null;
        m_MediaWidth = ndis.readInt();
        m_MediaHeight = ndis.readInt();
        if(m_Version < 0xda360003) {
            m_LayoutInfo.m_TransWidth = 0;
            m_LayoutInfo.m_TransHeight = 0;
            m_LayoutInfo.m_SlideWidth = 0;
            m_LayoutInfo.m_SlideHeight = 0;
            m_LayoutInfo.m_Reserved = 0;
        } else {
            m_LayoutInfo.m_TransWidth = ndis.readInt();
            m_LayoutInfo.m_TransHeight = ndis.readInt();
            m_LayoutInfo.m_SlideWidth = ndis.readInt();
            m_LayoutInfo.m_SlideHeight = ndis.readInt();
            m_LayoutInfo.m_Reserved = ndis.readInt();
        }
    }
}
