// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 14:53:14 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.plg;

import communities.ButtonPanel;
import communities.IPalaceCore;
import communities.sec.IPalaceSecurity;
import communities.sec.Privileged;
import communities.utl.ImagePane;
import communities.utl.ResourceInfo;
import java.awt.*;
import java.net.MalformedURLException;
import java.net.URL;

// Referenced classes of package communities.plg:
//            ImageButton, EventList, PalPresentsEventGrabber, EventListRec, 
//            StageDesc

final class StageInputPanel extends Panel
    implements Privileged {

    private boolean m_userQues;
    PalPresentsEventGrabber m_pProtocol;
    ResourceInfo resInfo;
    TextField m_textInput;
    ButtonPanel m_ButtonPanel;
    ImageButton m_OnStageBtn;
    ImageButton m_ExitBtn;
    ImageButton m_InfoBtn;
    Image m_InvitemeImg;
    Image m_InvitemeDownImg;
    Image m_DInvitemeImg;
    Image m_ExitstageImg;
    Image m_ExitstageDownImg;
    Image m_DExitstageImg;
    Image m_OffstageImg;
    Image m_OffstageDownImg;
    Image m_DOffstageImg;
    Image m_EventinfoImg;
    Image m_EventinfoDownImg;
    Image m_DEventinfoImg;
    boolean m_Init;
    private transient IPalaceSecurity mSecurity;

    public void YouAreOnStage() {
        m_ButtonPanel.setHelpText(m_OnStageBtn, "Leave the stage");
        m_OnStageBtn.setImage(m_OffstageImg, m_OffstageDownImg, m_DOffstageImg);
        if(!m_userQues) {
            m_textInput.setText("");
            m_textInput.enable();
            m_textInput.setForeground(Color.black);
            m_textInput.setBackground(Color.white);
        }
    }

    public void setSecurity(IPalaceSecurity m) {
        mSecurity = m;
    }

    public StageInputPanel(PalPresentsEventGrabber pProtocol, ResourceInfo resInfo) {
        m_userQues = true;
        m_pProtocol = null;
        this.resInfo = null;
        m_textInput = null;
        m_ButtonPanel = null;
        m_OnStageBtn = null;
        m_ExitBtn = null;
        m_InfoBtn = null;
        m_InvitemeImg = null;
        m_InvitemeDownImg = null;
        m_DInvitemeImg = null;
        m_ExitstageImg = null;
        m_ExitstageDownImg = null;
        m_DExitstageImg = null;
        m_OffstageImg = null;
        m_OffstageDownImg = null;
        m_DOffstageImg = null;
        m_EventinfoImg = null;
        m_EventinfoDownImg = null;
        m_DEventinfoImg = null;
        m_Init = false;
        m_pProtocol = pProtocol;
        this.resInfo = resInfo;
    }

    public void OnClickm_InfoBtn() {
        EventList evtList = m_pProtocol.mEventList;
        int currStageID = m_pProtocol.m_StageID;
        EventListRec evtListRec = evtList.findEvent(currStageID);
        if(evtListRec != null && evtListRec.m_eventInfoURL != null && evtListRec.m_eventInfoURL.length() > 1)
            m_pProtocol.mApplet.gotoURL(evtListRec.m_eventInfoURL, "Event Info");
    }

    public void StageDesc(StageDesc stageDesc) {
        if(resInfo.eventInfoButtonEnabled)
            if(stageDesc.m_InfoURL.length() > 0)
                m_InfoBtn.enable();
            else
                m_InfoBtn.disable();
        if(stageDesc.m_flags != 0 && (stageDesc.m_flags & 4) != 0) {
            m_userQues = true;
            m_textInput.setText("");
            m_textInput.enable();
            m_textInput.setForeground(Color.black);
            m_textInput.setBackground(Color.white);
        } else {
            m_userQues = false;
            m_textInput.setForeground(Color.white);
            m_textInput.setBackground(Color.gray);
            m_textInput.setText("Audience questions NOT allowed in this event.");
            m_textInput.disable();
        }
        repaint();
    }

    public void setShape() {
        m_OnStageBtn.setImage(m_InvitemeImg);
        Dimension dm = m_ExitBtn.preferredSize();
        m_ButtonPanel.reshape(0, 0, resInfo.textInputRect.width, dm.height + 8);
        int endX = resInfo.textInputRect.width;
        int x = 0;
        if(resInfo.back2RoomButtonEnabled) {
            m_ExitBtn.reshape(endX - dm.width, 0, dm.width, dm.height);
            x = dm.width;
        }
        if(resInfo.eventInfoButtonEnabled) {
            dm = m_InfoBtn.preferredSize();
            m_InfoBtn.reshape(endX - (dm.width + x), 0, dm.width, dm.height);
            x += dm.width;
        }
        if(resInfo.stageInviteButtonEnabled) {
            dm = m_OnStageBtn.preferredSize();
            m_OnStageBtn.reshape(endX - (dm.width + x), 0, dm.width, dm.height);
            x += dm.width;
        }
        m_textInput.reshape(0, 0, resInfo.textInputRect.width - (x + 4), resInfo.textInputRect.height);
    }

    public boolean chatStringContainsValidChars(String s) {
        for(int i = 0; i < s.length(); i++)
            if(s.charAt(i) >= '!')
                return true;

        return false;
    }

    public void YouAreOffStage() {
        m_ButtonPanel.setHelpText(m_OnStageBtn, "Invite me onstage");
        m_OnStageBtn.setImage(m_InvitemeImg, m_InvitemeDownImg, m_DInvitemeImg);
    }

    public void Init() {
        if(m_Init)
            return;
        String appdataFolder = m_pProtocol.getAppletDataFolder();
        if(appdataFolder != null) {
            appdataFolder += "resource/";
            try {
                StageInputPanel$ImageGetter getter = new StageInputPanel$ImageGetter(this, appdataFolder);
                URL aURL = new URL(appdataFolder);
                mSecurity.connectTo(aURL, getter);
            }
            catch(MalformedURLException mfu) { }
            catch(SecurityException e) { }
        }
        m_ButtonPanel = new ButtonPanel(3, m_pProtocol.mApplet);
        m_ButtonPanel.setLayout(null);
        m_textInput = new TextField(60);
        m_textInput.setFont(resInfo.textInputFont);
        m_textInput.setBackground(Color.white);
        if(resInfo.stageInviteButtonEnabled) {
            m_OnStageBtn = new ImageButton(m_InvitemeImg, m_InvitemeDownImg, m_DInvitemeImg, 34, 34, 0);
            m_OnStageBtn.setBkMode(true);
            m_OnStageBtn.resize(m_OnStageBtn.preferredSize());
            m_ButtonPanel.addButton(m_OnStageBtn, "Invite me onstage");
        }
        if(resInfo.eventInfoButtonEnabled) {
            m_InfoBtn = new ImageButton(m_EventinfoImg, m_EventinfoDownImg, m_DEventinfoImg, 34, 34, 0);
            m_InfoBtn.setBkMode(true);
            m_InfoBtn.resize(m_InfoBtn.preferredSize());
            m_ButtonPanel.addButton(m_InfoBtn, "Show information about event");
        }
        m_ExitBtn = new ImageButton(m_ExitstageImg, m_ExitstageDownImg, m_DExitstageImg, 72, 34, 0);
        if(resInfo.back2RoomButtonEnabled) {
            m_ExitBtn = new ImageButton(m_ExitstageImg, m_ExitstageDownImg, m_DExitstageImg, 72, 34, 0);
            m_ExitBtn.setFont(new Font("Courier", 0, 12));
            m_ExitBtn.setBkMode(true);
            m_ExitBtn.resize(m_ExitBtn.preferredSize());
            m_ButtonPanel.addButton(m_ExitBtn, "Leave the event");
        }
        add(m_ButtonPanel);
        m_ButtonPanel.add(m_textInput);
        m_Init = true;
    }

    public boolean handleEvent(Event evt) {
        switch(evt.id) {
        case 201: // Event.WINDOW_DESTROY
        case 501: // Event.MOUSE_DOWN
        case 503: // Event.MOUSE_MOVE
        default:
            break;

        case 401: // Event.KEY_PRESS
            if(evt.target != m_textInput || evt.key != 10)
                break;
            String s = m_textInput.getText();
            if(chatStringContainsValidChars(s))
                if(m_pProtocol.amIonStage())
                    m_pProtocol.ChatOnStage(s);
                else
                    m_pProtocol.AskQuestion(s);
            m_textInput.setText("");
            return true;

        case 1001: // Event.ACTION_EVENT
            if(evt.target == m_OnStageBtn) {
                if(m_pProtocol.amIonStage())
                    m_pProtocol.LeaveStage();
                else
                    m_pProtocol.AskOnStage();
                break;
            }
            if(evt.target == m_ExitBtn) {
                m_pProtocol.shutDown();
                break;
            }
            if(evt.target == m_InfoBtn)
                OnClickm_InfoBtn();
            break;
        }
        return super.handleEvent(evt);
    }

    public void removeNotify() {
        m_ButtonPanel.reset();
        super.removeNotify();
    }
}
