// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 15:04:52 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.pob;

import communities.utl.NetDataInputStream;
import java.awt.Graphics;
import java.io.ByteArrayInputStream;
import java.io.IOException;

// Referenced classes of package communities.pob:
//            Room2D, ImageOverlay

public class HStateRec {

    public int pictID;
    public int y;
    public int x;

    public void draw(Graphics g, int ox, int oy, Room2D itsRoom) {
        ImageOverlay img = itsRoom.getImageOverlay(pictID);
        if(img == null) {
            return;
        } else {
            img.draw(g, x + ox, y + oy, itsRoom);
            return;
        }
    }

    public HStateRec() {
        pictID = 0;
        y = 0;
        x = 0;
    }

    public void fromBytes(boolean bigEndian, byte bs[], int off) throws IOException {
        ByteArrayInputStream bis = new ByteArrayInputStream(bs, off, size());
        NetDataInputStream ndis = new NetDataInputStream(bis);
        ndis.setBigEndian(bigEndian);
        pictID = ndis.readShort();
        ndis.readShort();
        y = ndis.readShort();
        x = ndis.readShort();
    }

    public static int size() {
        return 8;
    }
}
