// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 15:04:52 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.pob;

import communities.utl.NetDataInputStream;
import java.awt.Graphics;
import java.awt.Image;
import java.io.ByteArrayInputStream;
import java.io.IOException;

// Referenced classes of package communities.pob:
//            Room2D

public class ImageOverlay {

    int refCon;
    public int picID;
    int transColor;
    public String picName;
    Image img;

    public void draw(Graphics g, int x, int y, Room2D room) {
        java.awt.Canvas canvas = room.itsCanvas;
        if(img != null && canvas != null)
            g.drawImage(img, x - img.getWidth(canvas) / 2, y - img.getHeight(canvas) / 2, canvas);
        else
        if(picName != null)
            g.drawString(picName, x, y + 20);
    }

    public ImageOverlay() {
        refCon = 0;
        picID = 0;
        transColor = 0;
        picName = null;
        img = null;
    }

    protected String getString(byte bs[], int start) {
        int count = bs[start++];
        String s = new String(bs, 0, start, count);
        return s;
    }

    public void fromBytes(boolean bigEndian, byte bs[], int off) throws IOException {
        ByteArrayInputStream bis = new ByteArrayInputStream(bs, off, size());
        NetDataInputStream ndis = new NetDataInputStream(bis);
        ndis.setBigEndian(bigEndian);
        refCon = ndis.readInt();
        picID = ndis.readShort();
        int picNameOfst = ndis.readShort();
        transColor = ndis.readShort();
        ndis.readShort();
        if(picNameOfst > 0)
            picName = getString(bs, picNameOfst);
    }

    public static int size() {
        return 12;
    }

    public void setImage(Image itsImage) {
        img = itsImage;
    }
}
