// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 15:11:51 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.sec;

import communities.instantpal;
import java.applet.Applet;
import java.io.PrintStream;
import java.net.URL;

// Referenced classes of package communities.sec:
//            IPalaceSecurity, MicrosoftSecurity, NetscapeSecurity, JavaSecurityAirlock, 
//            NullSecurity

public final class PalaceSecurityManager
    implements IPalaceSecurity {

    private static PalaceSecurityManager theInstance = null;
    private static IPalaceSecurity theSecurity = null;

    public static void initialize(instantpal palace) throws SecurityException {
        if(theInstance == null) {
            System.err.println("Creating the Palace Security Manager.");
            palace.setPalaceSecurity(new PalaceSecurityManager(palace.getJavaApplet()));
        } else {
            palace.setPalaceSecurity(theInstance);
        }
    }

    void setSecurity(IPalaceSecurity sec) {
        if(theSecurity != null) {
            throw new SecurityException("Attempt to assign second security manager");
        } else {
            theSecurity = sec;
            return;
        }
    }

    public void connectTo(URL aURL, Runnable theCode) {
        theSecurity.connectTo(aURL, theCode);
    }

    private PalaceSecurityManager(Applet applet) {
        String param = applet.getParameter("nullSecurity");
        if(param == null || param.equalsIgnoreCase("false")) {
            MicrosoftSecurity.initialize(this);
            if(theSecurity == null)
                NetscapeSecurity.initialize(this);
            if(theSecurity == null)
                JavaSecurityAirlock.initialize(this);
        }
        if(theSecurity == null)
            NullSecurity.initialize(this);
    }

}
