// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 15:14:58 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.spb;

import java.awt.Color;
import java.util.Date;
import java.util.Vector;

// Referenced classes of package communities.spb:
//            SerialSpeech

public class SpeechMessage {

    protected String msg;
    protected long birthTime;
    public Vector lines;
    public int flags;
    public int spoofX;
    public int spoofY;
    public String soundName;
    long myDelay;
    Color myMagenta;
    public SerialSpeech m_serSpch;

    public String msg() {
        return msg;
    }

    public SpeechMessage(String msg, int msgFlags, int msgDelay, SerialSpeech serSpch) {
        this.msg = null;
        birthTime = 0L;
        lines = null;
        flags = 0;
        spoofX = 0;
        spoofY = 0;
        soundName = null;
        myDelay = 0L;
        m_serSpch = null;
        m_serSpch = serSpch;
        flags = msgFlags;
        myMagenta = new Color(190, 0, 200);
        int i;
label0:
        for(i = 0; i < msg.length();)
            switch(msg.charAt(i)) {
            default:
                break label0;

            case 33: // '!'
                flags |= 1;
                i++;
                break;

            case 58: // ':'
                flags |= 4;
                i++;
                break;

            case 94: // '^'
                flags |= 8;
                i++;
                break;

            case 42: // '*'
                flags |= 0x20;
                i++;
                break;

            case 64: // '@'
                flags |= 0x40;
                i++;
                if(!Character.isDigit(msg.charAt(i)))
                    break;
                char xdigits[] = new char[6];
                char ydigits[] = new char[6];
                int xn = 0;
                int yn = 0;
                while(i < msg.length() && xn < 6 && (msg.charAt(i) == '-' || Character.isDigit(msg.charAt(i)))) 
                    xdigits[xn++] = msg.charAt(i++);
                if(i < msg.length() && msg.charAt(i) == ' ')
                    i++;
                if(i < msg.length() && msg.charAt(i) == ',')
                    i++;
                if(i < msg.length() && msg.charAt(i) == ' ')
                    i++;
                while(i < msg.length() && yn < 6 && (msg.charAt(i) == '-' || Character.isDigit(msg.charAt(i)))) 
                    ydigits[yn++] = msg.charAt(i++);
                if(i < msg.length() && msg.charAt(i) == ' ')
                    i++;
                if(i < msg.length() && msg.charAt(i) == ',')
                    i++;
                if(i < msg.length() && msg.charAt(i) == ' ')
                    i++;
                try {
                    spoofX = Integer.parseInt(new String(xdigits, 0, xn));
                    spoofY = Integer.parseInt(new String(ydigits, 0, yn));
                    break;
                }
                catch(NumberFormatException e) {
                    spoofX = 10;
                }
                spoofY = 10;
                break;
            }

        if((flags & 0x180) > 0)
            flags &= -9;
        if(i > 0)
            this.msg = msg.substring(i);
        else
            this.msg = msg;
        birthTime = (new Date()).getTime();
        if(msgDelay < 6000) {
            myDelay = this.msg.length() * 180;
            if(myDelay < 6000L)
                myDelay = 6000L;
        } else {
            myDelay = msgDelay;
        }
    }

    public Color getColor() {
        Color c;
        if((flags & 2) > 0)
            c = myMagenta;
        else
        if((flags & 0x80) > 0)
            c = Color.black;
        else
        if((flags & 0x100) > 0)
            c = Color.blue;
        else
            c = Color.black;
        return c;
    }

    int age() {
        if((flags & 8) > 0)
            return 1;
        else
            return (int)((new Date()).getTime() - birthTime);
    }

    public long getDelayTime() {
        int age = age();
        if((long)age < myDelay)
            return myDelay - (long)age;
        else
            return -1L;
    }
}
