// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 15:15:06 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.utl;

import communities.IPalaceCore;
import java.applet.AudioClip;
import java.io.PrintStream;

// Referenced classes of package communities.utl:
//            ResourceInfo, PalaceSoundManager

public class PalaceSound extends Thread {

    private AudioClip mAudioClip;
    private IPalaceCore mCore;
    private String mSoundName;

    public String toString() {
        return mSoundName;
    }

    public PalaceSound(String soundMessage, IPalaceCore core) {
        mAudioClip = null;
        mCore = null;
        mSoundName = null;
        mCore = core;
        if(soundMessage.charAt(0) == ')')
            mSoundName = soundMessage.substring(1);
        else
            mSoundName = soundMessage;
        mAudioClip = mCore.getResourceInfo().getSound(mSoundName);
    }

    public AudioClip getAudioClip() {
        return mAudioClip;
    }

    public void run() {
        if(mAudioClip != null) {
            mCore.getSoundManager().addSound(this);
            mAudioClip.play();
        }
        if(mCore.getResourceInfo().getDebug() > 0)
            System.out.println("Sound done");
    }
}
