// NMI's Java Code Viewer 6.0 
// http://www.njcv.tk

// Generated Tue Apr 15 2003 15:15:06 

// Source File Name:   [DashoPro-V1.2-120198]

package communities.utl;

import communities.IPalaceCore;
import communities.PalaceErrorHandler;
import communities.plg.IPalacePresents;
import communities.pob.Room2D;
import communities.sec.IPalaceSecurity;
import java.applet.Applet;
import java.applet.AudioClip;
import java.awt.*;
import java.io.PrintStream;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Vector;

// Referenced classes of package communities.utl:
//            PalaceURL, ItemLister

public final class ResourceInfo {

    private transient IPalaceSecurity mSecurity;
    private int mConnectionTimeout;
    private PalaceErrorHandler mErrorHandler;
    private int mHTTPPort;
    private int mHTTPDelay;
    Applet mApplet;
    private String mSoundsDir;
    private URL mImageList;
    private URL mSoundList;
    private String mPicFolder;
    private int mPalacePort;
    private URL mHelpFile;
    private String mAppletData;
    private String mAppletHost;
    private int mAppletPort;
    private IPalaceCore mCore;
    Image mFaceProps[][];
    private int mDebug;
    private URL mPalPresentsHelpFile;
    private String mCacheFolder;
    private String mFacesDir;
    public URL joinURL;
    public URL adURL;
    public URL homeURL;
    public static int RED = 0;
    public static int ORANGE = 1;
    public static int YELLOW = 2;
    public static int GREEN = 3;
    public static int LT_BLUE = 4;
    public static int BLUE = 5;
    public static int PURPLE = 6;
    public static int PINK = 7;
    public int appletMode;
    public boolean scriptingEnabled;
    private boolean mPPOn;
    public int mRmID;
    public boolean roomWindowEnabled;
    public Rectangle roomWindowRect;
    public boolean bounceIntoRoom;
    public Rectangle textInputRect;
    public Font textInputFont;
    public int textInputFontSize;
    public boolean statusLabelEnabled;
    public Rectangle statusLabelRect;
    public Font statusLabelFont;
    public int statusLabelFontSize;
    public boolean tabPanelEnabled;
    public boolean PPTabPanelEnabled;
    public boolean tabPanelFloats;
    public Rectangle tabPanelRect;
    public boolean logPanelEnabled;
    public boolean userPanelEnabled;
    public boolean roomPanelEnabled;
    public boolean helpPanelEnabled;
    public boolean avatarPanelEnabled;
    public boolean eventsPanelEnabled;
    public boolean soundPanelEnabled;
    public boolean aboutPanelEnabled;
    public boolean PPTranscriptPanelEnabled;
    public boolean PPUserPanelEnabled;
    public boolean PPHelpPanelEnabled;
    public boolean PPAboutPanelEnabled;
    public boolean adminPanelEnabled;
    public boolean urlPanelEnabled;
    public Font logFont;
    public int logType;
    public int logBuffSize;
    public int logFontSize;
    public Color logFontColor;
    public Color logNameColor;
    public Color logPrivateColor;
    public Color logSystemColor;
    public boolean buttonPanelEnabled;
    public boolean buttonsHilight;
    public boolean buttonsShift;
    public Rectangle buttonPanelRect;
    public boolean stageInviteButtonEnabled;
    public boolean eventInfoButtonEnabled;
    public boolean back2RoomButtonEnabled;
    public boolean navBarEnabled;
    public Rectangle navBarRect;
    public boolean adEnabled;
    public Rectangle adRect;
    public Font balloonFont;
    public int balloonFontSize;
    public boolean bRunIntro;
    public boolean chooseNameEnabled;
    public boolean chooseAvatarEnabled;
    public boolean tutorialEnabled;
    public String defaultName;
    public int defaultAvatar;
    public int defaultFaceColor;
    public boolean bLowResEnabled;
    public Color bkgColor;
    public boolean bDrawAppletBorder;
    public boolean messageBoxOnPage;
    public boolean dingOnPage;
    public String customStringList[];

    public Image getFace(int expression, int color) {
        Image face;
        try {
            face = mFaceProps[expression][color];
        }
        catch(ArrayIndexOutOfBoundsException e) {
            face = null;
        }
        return face;
    }

    public PalaceURL getPalaceHTTPURL() {
        if(isHTTPAvail()) {
            try {
                return new PalaceURL("http", mAppletHost, mHTTPPort, "");
            }
            catch(MalformedURLException e) {
                mErrorHandler.reportError("init: palace http url bad", 1);
            }
            return null;
        } else {
            return null;
        }
    }

    public void setSecurity(IPalaceSecurity m) {
        mSecurity = m;
    }

    public int getConnectionTimeout() {
        return mConnectionTimeout;
    }

    private Color getColorParam(String sParam, Color defaultColor) {
        String colorStr = getStringParam(sParam);
        if(colorStr == null)
            return defaultColor;
        else
            return new Color(Integer.valueOf(colorStr, 16).intValue());
    }

    private void getUIParams() {
        String sParam = getStringParam("Mode");
        if(sParam == null || sParam.compareTo("FULL") == 0)
            appletMode = 1;
        else
        if(sParam.compareTo("NO_PP") == 0) {
            appletMode = 3;
            mPPOn = false;
        } else
        if(sParam.compareTo("NO_UI") == 0) {
            appletMode = 2;
            scriptingEnabled = false;
        } else
        if(sParam.compareTo("CORE") == 0) {
            appletMode = 4;
            mPPOn = false;
            scriptingEnabled = false;
        } else
        if(sParam.compareTo("ADMIN") == 0) {
            appletMode = 5;
            getAdminParams();
        } else {
            appletMode = 1;
        }
        roomWindowEnabled = getBooleanParam("RoomWindowEnabled", true);
        if(roomWindowEnabled)
            roomWindowRect = getRectParam("RoomWindowPos", "RoomWindowSize", 2, 2, 512, 384);
        bounceIntoRoom = getBooleanParam("BounceIntoRoom", true);
        textInputRect = getRectParam("textInputPos", "textInputSize", 2, 388, 512, 22);
        textInputFontSize = getIntParam("TextInputFontSize");
        if(textInputFontSize == -1)
            textInputFontSize = 12;
        textInputFont = getFontParam("TextInputFont", textInputFontSize, "Dialog");
        statusLabelEnabled = getBooleanParam("StatusLabelEnabled", true);
        if(statusLabelEnabled)
            statusLabelRect = getRectParam("StatusLabelPos", "StatusLabelSize", 2, 412, 512, 20);
        statusLabelFontSize = getIntParam("StatusLabelFontSize");
        if(statusLabelFontSize == -1)
            statusLabelFontSize = 12;
        statusLabelFont = getFontParam("StatusLabelFont", statusLabelFontSize, "Dialog");
        getTabPanelParams();
        buttonPanelEnabled = getBooleanParam("ButtonPanelEnabled", true);
        if(buttonPanelEnabled) {
            buttonsHilight = getBooleanParam("ButtonsHilight", true);
            buttonsShift = getBooleanParam("ButtonsShift", true);
            buttonPanelRect = getRectParam("ButtonPanelPos", "ButtonPanelSize", 566, 64, 194, 100);
        }
        stageInviteButtonEnabled = getBooleanParam("StageInviteButtonEnabled", true);
        back2RoomButtonEnabled = getBooleanParam("Back2RoomButtonEnabled", true);
        eventInfoButtonEnabled = getBooleanParam("EventInfoButtonEnabled", true);
        navBarEnabled = getBooleanParam("NavBarEnabled", true);
        if(navBarEnabled)
            navBarRect = getRectParam("NavBarPos", "NavBarSize", 522, 64, 36, 100);
        adEnabled = getBooleanParam("AdEnabled", true);
        if(adEnabled)
            adRect = getRectParam("AdPos", "AdSize", 522, 2, 236, 60);
        chooseNameEnabled = getBooleanParam("ChooseNameEnabled", true);
        chooseAvatarEnabled = getBooleanParam("ChooseAvatarEnabled", true);
        tutorialEnabled = getBooleanParam("TutorialEnabled", true);
        if(chooseNameEnabled || chooseAvatarEnabled || tutorialEnabled)
            bRunIntro = true;
        else
            bRunIntro = false;
        balloonFontSize = getIntParam("BalloonFontSize");
        if(balloonFontSize == -1)
            balloonFontSize = 10;
        balloonFont = getFontParam("BalloonFont", balloonFontSize, "Dialog");
        defaultName = getStringParam("DefaultName");
        if(defaultName == null)
            defaultName = new String("Guest");
        defaultAvatar = getIntParam("DefaultAvatar");
        if(defaultAvatar == -1) {
            defaultAvatar = 0;
            defaultFaceColor = 3;
        } else {
            defaultFaceColor = 3;
            defaultAvatar = defaultAvatar % 13 - 1;
            defaultAvatar = defaultAvatar < 0 ? 0 : defaultAvatar;
        }
        bLowResEnabled = getBooleanParam("LowResModeEnabled", false);
        bkgColor = getColorParam("BkgColor", Color.lightGray);
        bDrawAppletBorder = getBooleanParam("DrawAppletBorder", true);
    }

    public Image[][] getFaceProps() {
        return mFaceProps;
    }

    public void setPalaceHostURL(PalaceURL aURL) {
        mAppletHost = aURL.getURL().getHost();
        mPalacePort = aURL.getURL().getPort();
    }

    public PalaceURL getPalaceHostURL() {
        try {
            return new PalaceURL("palace", mAppletHost, mPalacePort, "");
        }
        catch(MalformedURLException e) {
            mErrorHandler.reportError("Bad URL:" + e.getMessage(), 1);
        }
        return null;
    }

    public URL getSoundList() {
        return mSoundList;
    }

    public URL getHelpFile() {
        return mHelpFile;
    }

    public PalaceErrorHandler getErrorHandler() {
        return mErrorHandler;
    }

    public String getSoundsDir() {
        return mSoundsDir;
    }

    public static URL createURL(String stringRep) {
        URL url;
        try {
            url = new URL(stringRep);
        }
        catch(MalformedURLException e) {
            url = null;
        }
        return url;
    }

    public int getDebug() {
        return mDebug;
    }

    public boolean isHTTPAvail() {
        return mHTTPPort > 0;
    }

    private void getTabPanelParams() {
        tabPanelFloats = getBooleanParam("tabPanelFloats", false);
        tabPanelRect = getRectParam("TabPanelPos", "TabPanelSize", 522, 166, 238, 272);
        logPanelEnabled = getBooleanParam("LogPanelEnabled", true);
        userPanelEnabled = getBooleanParam("UserPanelEnabled", true);
        roomPanelEnabled = getBooleanParam("RoomPanelEnabled", true);
        helpPanelEnabled = getBooleanParam("HelpPanelEnabled", true);
        avatarPanelEnabled = getBooleanParam("AvatarPanelEnabled", true);
        eventsPanelEnabled = getBooleanParam("EventsPanelEnabled", true);
        soundPanelEnabled = getBooleanParam("SoundPanelEnabled", true);
        aboutPanelEnabled = getBooleanParam("AboutPanelEnabled", true);
        PPTranscriptPanelEnabled = getBooleanParam("PPTranscriptPanelEnabled", true);
        PPUserPanelEnabled = getBooleanParam("PPUserPanelEnabled", true);
        PPHelpPanelEnabled = getBooleanParam("PPHelpPanelEnabled", true);
        PPAboutPanelEnabled = getBooleanParam("PPAboutPanelEnabled", true);
        if(appletMode == 5) {
            adminPanelEnabled = getBooleanParam("AdminPanelEnabled", false);
            urlPanelEnabled = getBooleanParam("URLPanelEnabled", false);
        }
        logFontSize = getIntParam("LogFontSize");
        if(logFontSize == -1)
            logFontSize = 12;
        logFont = getFontParam("LogFont", logFontSize, "Dialog");
        logFontColor = getColorParam("LogFontColor", Color.black);
        logNameColor = getColorParam("LogNameColor", new Color(0, 130, 0));
        logPrivateColor = getColorParam("LogPrivateColor", new Color(160, 0, 170));
        logSystemColor = getColorParam("LogSystemColor", new Color(200, 0, 0));
        if(logPanelEnabled || userPanelEnabled || roomPanelEnabled || helpPanelEnabled || avatarPanelEnabled || eventsPanelEnabled || aboutPanelEnabled || soundPanelEnabled)
            tabPanelEnabled = true;
        else
            tabPanelEnabled = false;
        if(PPTranscriptPanelEnabled || PPUserPanelEnabled || PPHelpPanelEnabled || PPAboutPanelEnabled)
            PPTabPanelEnabled = true;
        else
            PPTabPanelEnabled = false;
    }

    private void getHTTPParams() {
        int hPort = getIntParam("tunnel_port");
        mHTTPPort = hPort < 0 ? 0 : hPort;
        int hDelay = getIntParam("tunnel_tryafter");
        mHTTPDelay = hDelay < 0 || mHTTPPort <= 0 ? 1 : hDelay;
    }

    public void setPicFolder(String aFolder) {
        if(aFolder == null || aFolder.compareTo("") == 0) {
            mPicFolder = getStringURLParam("picfolder");
            if(mPicFolder == null)
                mPicFolder = "http://" + mAppletHost + ":" + mAppletPort + "/palace/media/";
        } else {
            mPicFolder = aFolder;
        }
        System.out.println("pictures are in " + mPicFolder);
    }

    public String getPicFolder() {
        return mPicFolder;
    }

    private void getButtonURLS() {
        URL urlFile = getAppletDataFolder() != null ? createURL(getAppletDataFolder() + "resource/urllist.txt") : null;
        if(urlFile != null) {
            ItemLister urlList = new ItemLister(mErrorHandler, urlFile);
            urlList.setSecurity(mSecurity);
            char buf[] = new char[512];
            Vector v = urlList.getList();
            if(v == null) {
                mErrorHandler.reportError("Unable to access applet data - check appletdata parameter.", 1);
            } else {
                String s = (String)v.elementAt(0);
                int colonIndex = s.indexOf(':');
                s.getChars(colonIndex + 1, s.length(), buf, 0);
                String joinString = new String(buf);
                joinURL = createURL(joinString);
                s = (String)urlList.getList().elementAt(1);
                colonIndex = s.indexOf(':');
                s.getChars(colonIndex + 1, s.length(), buf, 0);
                String adString = new String(buf);
                adURL = createURL(adString);
                s = (String)v.elementAt(2);
                colonIndex = s.indexOf(':');
                String homeString = new String(s.substring(colonIndex + 1));
                homeURL = createURL(homeString);
            }
        }
    }

    private void getCustomStrings() {
        URL stringFile = getAppletDataFolder() != null ? createURL(getAppletDataFolder() + "resource/strings.txt") : null;
        if(stringFile != null) {
            ItemLister stringList = new ItemLister(mErrorHandler, stringFile);
            stringList.setSecurity(mSecurity);
            Vector v = stringList.getList();
            if(v != null) {
                char buf[] = new char[512];
                customStringList = new String[5];
                for(int i = 0; i < 5; i++) {
                    String s = (String)v.elementAt(i);
                    int colonIndex = s.indexOf(':');
                    int len = s.length();
                    s.getChars(colonIndex + 1, len, buf, 0);
                    customStringList[i] = new String(buf, 0, len - colonIndex - 1);
                }

            }
        }
    }

    private Rectangle getRectParam(String pos, String dims, int defX, int defY, int defWidth, int defHeight) {
        String sPoint = getStringParam(pos);
        String sDim = getStringParam(dims);
        if(sPoint != null && sDim != null)
            return buildRect(sPoint, sDim);
        else
            return new Rectangle(defX, defY, defWidth, defHeight);
    }

    private Font getFontParam(String paramName, int fontSize, String defaultFont) {
        String sFont = getStringParam(paramName);
        if(sFont != null) {
            Font f = new Font(sFont, 0, fontSize);
            if(f == null)
                System.out.println("Invalid Font Param: " + paramName);
            return f;
        } else {
            return new Font(defaultFont, 0, fontSize);
        }
    }

    public ResourceInfo(IPalaceCore theCore) {
        mConnectionTimeout = 0;
        mHTTPPort = 0;
        mHTTPDelay = 0;
        mApplet = null;
        mSoundsDir = null;
        mImageList = null;
        mSoundList = null;
        mPicFolder = null;
        mPalacePort = 0;
        mHelpFile = null;
        mAppletData = null;
        mAppletHost = null;
        mAppletPort = 0;
        mCore = null;
        mFaceProps = null;
        mDebug = 0;
        mPalPresentsHelpFile = null;
        mCacheFolder = null;
        mFacesDir = null;
        joinURL = null;
        adURL = null;
        homeURL = null;
        appletMode = 1;
        scriptingEnabled = true;
        mPPOn = true;
        mRmID = 0;
        roomWindowEnabled = true;
        bounceIntoRoom = true;
        textInputFontSize = 12;
        statusLabelEnabled = true;
        statusLabelFontSize = 12;
        tabPanelEnabled = true;
        PPTabPanelEnabled = true;
        tabPanelFloats = false;
        logPanelEnabled = true;
        userPanelEnabled = true;
        roomPanelEnabled = true;
        helpPanelEnabled = true;
        avatarPanelEnabled = true;
        eventsPanelEnabled = true;
        soundPanelEnabled = true;
        aboutPanelEnabled = true;
        PPTranscriptPanelEnabled = true;
        PPUserPanelEnabled = true;
        PPHelpPanelEnabled = true;
        PPAboutPanelEnabled = true;
        adminPanelEnabled = false;
        urlPanelEnabled = false;
        logType = 2;
        logBuffSize = 600;
        logFontSize = 12;
        buttonPanelEnabled = true;
        buttonsHilight = true;
        buttonsShift = true;
        stageInviteButtonEnabled = true;
        eventInfoButtonEnabled = true;
        back2RoomButtonEnabled = true;
        navBarEnabled = true;
        adEnabled = true;
        balloonFontSize = 12;
        bRunIntro = true;
        chooseNameEnabled = true;
        chooseAvatarEnabled = true;
        tutorialEnabled = true;
        defaultName = "Guest";
        defaultAvatar = 0;
        defaultFaceColor = 3;
        bLowResEnabled = false;
        bDrawAppletBorder = true;
        messageBoxOnPage = false;
        dingOnPage = false;
        mCore = theCore;
        mApplet = theCore.getJavaApplet();
        mDebug = getIntParam("debug");
        mErrorHandler = theCore.getErrorHandler();
        mAppletHost = getStringParam("palacehost");
        mAppletPort = getIntParam("palacehostport");
        mPicFolder = getStringURLParam("picfolder");
        mAppletData = getStringURLParam("appletdata");
        mCacheFolder = getStringParam("cachefolder");
        System.out.println("mApplet = " + mApplet);
        System.out.println("mAppletHost = " + mAppletHost);
        System.out.println("mAppletPort = " + mAppletPort);
        System.out.println("mAppletData = " + mAppletData);
        System.out.println("mPicFolder = " + mPicFolder);
        mHelpFile = getAppletDataFolder() != null ? createURL(getAppletDataFolder() + "help/javahelp.txt") : null;
        mPalPresentsHelpFile = getAppletDataFolder() != null ? createURL(getAppletDataFolder() + "help/ppjavahelp.txt") : null;
        mPalacePort = getIntParam("palaceport");
        mSoundsDir = getStringURLParam("soundfolder");
        mSoundList = getSoundsDir() != null ? createURL(getSoundsDir() + "soundlist.txt") : null;
    }

    public boolean isPalacePresentsEnabled() {
        return mPPOn;
    }

    private boolean getBooleanParam(String sParam, boolean defaultVal) {
        String sVal = getStringParam(sParam);
        if(sVal == null)
            return defaultVal;
        return sVal.compareTo("true") == 0;
    }

    public void setFacesDir(String facesDir) {
        if(facesDir == null || facesDir.compareTo("") == 0) {
            mFacesDir = getStringURLParam("avatars");
            if(mFacesDir == null)
                mFacesDir = "http://" + mAppletHost + ":" + mAppletPort + "/palace/avatars/";
        } else {
            mFacesDir = facesDir;
        }
        System.out.println("avatars are in " + mFacesDir);
        initFaces();
        mCore.getRoom().provideFaceProps(mFaceProps);
        if(mCore.getPalacePresents() != null)
            mCore.getPalacePresents().getRoom().provideFaceProps(mFaceProps);
    }

    public Image getIcon(String name) {
        String resourceDir = getResourceFolder();
        if(resourceDir == null)
            return null;
        URL iconLoc = createURL(resourceDir + name + ".gif");
        if(iconLoc != null) {
            ResourceInfo$ImageGetter getter = new ResourceInfo$ImageGetter(this, iconLoc);
            try {
                mSecurity.connectTo(iconLoc, getter);
            }
            catch(SecurityException e) { }
            return getter.mImage;
        } else {
            return null;
        }
    }

    public String getAppletDataFolder() {
        return mAppletData;
    }

    private void initFaces() {
        mFaceProps = new Image[13][8];
        for(int expression = 0; expression < 13; expression++) {
            for(int color = 0; color < 8; color++)
                mFaceProps[expression][color] = null;

        }

        if(mFacesDir == null)
            return;
        URL faceURL = createURL(mFacesDir);
        if(faceURL != null) {
            ResourceInfo$FaceGetter getter = new ResourceInfo$FaceGetter(this, faceURL);
            try {
                mSecurity.connectTo(faceURL, getter);
            }
            catch(SecurityException e) {
                mErrorHandler.reportError("Security Exception loading:" + faceURL, 1);
            }
        }
    }

    private Rectangle buildRect(String sPos, String sDim) {
        char buf[] = new char[256];
        sPos.getChars(0, sPos.length(), buf, 0);
        int i = sPos.indexOf(',');
        String sx = new String(buf, 0, i);
        String sy = new String(buf, i + 1, sPos.length() - i - 1);
        int x = Integer.valueOf(sx).intValue();
        int y = Integer.valueOf(sy).intValue();
        sDim.getChars(0, sDim.length(), buf, 0);
        i = sDim.indexOf(',');
        String swidth = new String(buf, 0, i);
        String sheight = new String(buf, i + 1, sDim.length() - i - 1);
        int width = Integer.valueOf(swidth).intValue();
        int height = Integer.valueOf(sheight).intValue();
        return new Rectangle(x, y, width, height);
    }

    public String getResourceFolder() {
        String dataDir = getAppletDataFolder();
        if(dataDir == null)
            return null;
        else
            return dataDir + "resource/";
    }

    public void init() {
        mConnectionTimeout = getIntParam("connectTimeout");
        if(mConnectionTimeout < 15)
            mConnectionTimeout = 15;
        else
        if(mConnectionTimeout > 60)
            mConnectionTimeout = 60;
        getUIParams();
        getButtonURLS();
        getCustomStrings();
        int gotRoom = getIntParam("entryroom");
        if(gotRoom >= 0)
            mRmID = gotRoom;
        getHTTPParams();
        logType = getIntParam("logtype");
        logType = logType != -1 && (logType == 2 || logType == 1) ? logType : 2;
        logBuffSize = getIntParam("logbuffersize");
        logBuffSize = logBuffSize < 50 ? 600 : logBuffSize;
    }

    public AudioClip getSound(String soundName) {
        AudioClip clip = null;
        String soundDir = getSoundsDir();
        if(soundDir != null) {
            URL soundURL = createURL(soundDir + soundName + ".au");
            if(soundURL != null)
                try {
                    ResourceInfo$AudioClipGetter g = new ResourceInfo$AudioClipGetter(this, soundURL);
                    mSecurity.connectTo(soundURL, g);
                    clip = g.mAudioClip;
                }
                catch(SecurityException e) {
                    mErrorHandler.reportError("Security Exception loading:" + soundURL, 1);
                }
        }
        return clip;
    }

    public int getHTTPDelay() {
        return mHTTPDelay;
    }

    private String getStringParam(String paramName) {
        String value = mApplet.getParameter(paramName);
        if((value == null || value.equals("")) && (paramName.compareTo("debug") != 0 || paramName.compareTo("run_intro") != 0))
            value = null;
        return value;
    }

    private void getAdminParams() {
        messageBoxOnPage = getBooleanParam("MessageBoxOnPage", false);
        dingOnPage = getBooleanParam("AudioNotifyOnPage", false);
    }

    private String getStringURLParam(String paramName) {
        String stringRep = getStringParam(paramName);
        System.out.println("Got paramName '" + paramName + "': it's stringRep '" + stringRep + "'");
        if(stringRep == null)
            return null;
        if(mAppletPort == -1 || mAppletPort == 80)
            return "http://" + mAppletHost + stringRep;
        else
            return "http://" + mAppletHost + ":" + mAppletPort + stringRep;
    }

    private int getIntParam(String paramName) {
        String stringRep = getStringParam(paramName);
        int value;
        if(stringRep != null)
            try {
                value = Integer.parseInt(stringRep);
            }
            catch(NumberFormatException e) {
                value = -1;
            }
        else
            value = -1;
        return value;
    }

    public URL getPalPresentsHelpFile() {
        return mPalPresentsHelpFile;
    }

}
